scala.collection.mutable

# ArrayStack

#### class ArrayStack[T] extends AbstractSeq[T] with Seq[T] with SeqLike[T, ArrayStack[T]] with GenericTraversableTemplate[T, ArrayStack] with Cloneable[ArrayStack[T]] with Builder[T, ArrayStack[T]] with Serializable

Simple stack class backed by an array. Should be significantly faster than the standard mutable stack.

T

  type of the elements contained in this array stack.

Annotations
  @SerialVersionUID( uid = 8565219180626620510L )
Source
  ArrayStack.scala
Since

  2.7

See also

  "Scala's Collection Library overview" section on `Array Stacks` for more information.

Linear Supertypes
Serializable, java.io.Serializable, Builder[T, ArrayStack[T]], Growable[T], Clearable, AbstractSeq[T], Seq[T], SeqLike[T, ArrayStack[T]], Cloneable[ArrayStack[T]], scala.Cloneable, java.lang.Cloneable, Iterable[T], Traversable[T], Mutable, collection.AbstractSeq[T], collection.Seq[T], collection.SeqLike[T, ArrayStack[T]], GenSeq[T], GenSeqLike[T, ArrayStack[T]], PartialFunction[Int, T], (Int) ⇒ T, collection.AbstractIterable[T], collection.Iterable[T], IterableLike[T, ArrayStack[T]], Equals, GenIterable[T], GenIterableLike[T, ArrayStack[T]], AbstractTraversable[T], collection.Traversable[T], GenTraversable[T], GenericTraversableTemplate[T, ArrayStack], TraversableLike[T, ArrayStack[T]], GenTraversableLike[T, ArrayStack[T]], Parallelizable[T, ParSeq[T]], TraversableOnce[T], GenTraversableOnce[T], FilterMonadic[T, ArrayStack[T]], HasNewBuilder[T, ArrayStack[T]], AnyRef, Any
Type Hierarchy Learn more about scaladoc diagrams
Ordering

1. Alphabetic
2. By inheritance

Inherited

1. ArrayStack
2. Serializable
3. Serializable
4. Builder
5. Growable
6. Clearable
7. AbstractSeq
8. Seq
9. SeqLike
10. Cloneable
11. Cloneable
12. Cloneable
13. Iterable
14. Traversable
15. Mutable
16. AbstractSeq
17. Seq
18. SeqLike
19. GenSeq
20. GenSeqLike
21. PartialFunction
22. Function1
23. AbstractIterable
24. Iterable
25. IterableLike
26. Equals
27. GenIterable
28. GenIterableLike
29. AbstractTraversable
30. Traversable
31. GenTraversable
32. GenericTraversableTemplate
33. TraversableLike
34. GenTraversableLike
35. Parallelizable
36. TraversableOnce
37. GenTraversableOnce
38. FilterMonadic
39. HasNewBuilder
40. AnyRef
41. Any

Implicitly

1. by traversable2ops
2. by MonadOps
3. by any2stringadd
4. by any2stringfmt
5. by any2ArrowAssoc
6. by any2Ensuring
7. by alternateImplicit

1. Hide All
2. Show all

Learn more about member selection
Visibility

1. Public
2. All

### Instance Constructors

1. #### new ArrayStack()

### Type Members

1. #### type Self = ArrayStack[T]

   The type implementing this traversable

   The type implementing this traversable

   Attributes
     protected
   Definition Classes
     TraversableLike

2. #### class WithFilter extends FilterMonadic[A, Repr]

   A class supporting filtered operations.

### Value Members

1. #### final def !=(arg0: AnyRef): Boolean

   Definition Classes
     AnyRef

2. #### final def !=(arg0: Any): Boolean

   Test two objects for inequality.

   Test two objects for inequality.

   returns

     `true` if !(this == that), false otherwise.

   Definition Classes
     Any

3. #### final def ##(): Int

   Equivalent to `x.hashCode` except for boxed numeric types and `null`.

   Equivalent to `x.hashCode` except for boxed numeric types and `null`. For numerics, it returns a hash value which is consistent with value equality: if two value type instances compare as true, then ## will produce the same hash value for each of them. For `null` returns a hashcode where `null.hashCode` throws a `NullPointerException`.

   returns

     a hash value consistent with ==

   Definition Classes
     AnyRef → Any

4. #### def +(other: String): String

   Implicit information
     This member is added by an implicit conversion from ArrayStack[T] to StringAdd performed by method any2stringadd in scala.Predef.
   Definition Classes
     StringAdd

5. #### def ++[B](that: GenTraversableOnce[B]): ArrayStack[B]

   [use case] Returns a new array stack containing the elements from the left hand operand followed by the elements from the right hand operand.

   [use case]

   Returns a new array stack containing the elements from the left hand operand followed by the elements from the right hand operand. The element type of the array stack is the most specific superclass encompassing the element types of the two operands.

   Example:

       scala> val a = LinkedList(1)
       a: scala.collection.mutable.LinkedList[Int] = LinkedList(1)

       scala> val b = LinkedList(2)
       b: scala.collection.mutable.LinkedList[Int] = LinkedList(2)

       scala> val c = a ++ b
       c: scala.collection.mutable.LinkedList[Int] = LinkedList(1, 2)

       scala> val d = LinkedList('a')
       d: scala.collection.mutable.LinkedList[Char] = LinkedList(a)

       scala> val e = c ++ d
       e: scala.collection.mutable.LinkedList[AnyVal] = LinkedList(1, 2, a)

   B

     the element type of the returned collection.

   that

     the traversable to append.

   returns

     a new array stack which contains all elements of this array stack followed by all elements of `that`.

   Definition Classes
     TraversableLike → GenTraversableLike
   Full Signature

   #### def ++[B >: T, That](that: GenTraversableOnce[B])(implicit bf: CanBuildFrom[ArrayStack[T], B, That]): That

6. #### def ++:[B >: T, That](that: collection.Traversable[B])(implicit bf: CanBuildFrom[ArrayStack[T], B, That]): That

   As with `++`, returns a new collection containing the elements from the left operand followed by the elements from the right operand.

   As with `++`, returns a new collection containing the elements from the left operand followed by the elements from the right operand.

   It differs from `++` in that the right operand determines the type of the resulting collection rather than the left one. Mnemonic: the COLon is on the side of the new COLlection type.

   Example:

       scala> val x = List(1)
       x: List[Int] = List(1)

       scala> val y = LinkedList(2)
       y: scala.collection.mutable.LinkedList[Int] = LinkedList(2)

       scala> val z = x ++: y
       z: scala.collection.mutable.LinkedList[Int] = LinkedList(1, 2)

   This overload exists because: for the implementation of `++:` we should reuse that of `++` because many collections override it with more efficient versions.

   Since `TraversableOnce` has no `++` method, we have to implement that directly, but `Traversable` and down can use the overload.

   B

     the element type of the returned collection.

   That

     the class of the returned collection. Where possible, `That` is the same class as the current collection class `Repr`, but this depends on the element type `B` being admissible for that class, which means that an implicit instance of type `CanBuildFrom[Repr, B, That]` is found.

   that

     the traversable to append.

   bf

     an implicit value of class `CanBuildFrom` which determines the result class `That` from the current representation type `Repr` and the new element type `B`.

   returns

     a new collection of type `That` which contains all elements of this array stack followed by all elements of `that`.

   Definition Classes
     TraversableLike

7. #### def ++:[B](that: TraversableOnce[B]): ArrayStack[B]

   [use case] As with `++`, returns a new collection containing the elements from the left operand followed by the elements from the right operand.

   [use case]

   As with `++`, returns a new collection containing the elements from the left operand followed by the elements from the right operand.

   It differs from `++` in that the right operand determines the type of the resulting collection rather than the left one. Mnemonic: the COLon is on the side of the new COLlection type.

   Example:

       scala> val x = List(1)
       x: List[Int] = List(1)

       scala> val y = LinkedList(2)
       y: scala.collection.mutable.LinkedList[Int] = LinkedList(2)

       scala> val z = x ++: y
       z: scala.collection.mutable.LinkedList[Int] = LinkedList(1, 2)

   B

     the element type of the returned collection.

   that

     the traversable to append.

   returns

     a new array stack which contains all elements of this array stack followed by all elements of `that`.

   Definition Classes
     TraversableLike
   Full Signature

   #### def ++:[B >: T, That](that: TraversableOnce[B])(implicit bf: CanBuildFrom[ArrayStack[T], B, That]): That

8. #### def ++=(xs: TraversableOnce[T]): ArrayStack.this.type

   Pushes all the provided elements in the traversable object onto the stack.

   Pushes all the provided elements in the traversable object onto the stack.

   xs

     The source of elements to push.

   returns

     A reference to this stack.

   Definition Classes
     ArrayStack → Growable

9. #### def +:(elem: A): ArrayStack[A]

   [use case] A copy of the array stack with an element prepended.

   [use case]

   A copy of the array stack with an element prepended.

   Note that :-ending operators are right associative (see example). A mnemonic for `+:` vs. `:+` is: the COLon goes on the COLlection side.

   Also, the original array stack is not modified, so you will want to capture the result.

   Example:

       scala> val x = LinkedList(1)
       x: scala.collection.mutable.LinkedList[Int] = LinkedList(1)

       scala> val y = 2 +: x
       y: scala.collection.mutable.LinkedList[Int] = LinkedList(2, 1)

       scala> println(x)
       LinkedList(1)

   elem

     the prepended element

   returns

     a new array stack consisting of `elem` followed by all elements of this array stack.

   Definition Classes
     SeqLike → GenSeqLike
   Full Signature

   #### def +:[B >: T, That](elem: B)(implicit bf: CanBuildFrom[ArrayStack[T], B, That]): That

10. #### def +=(x: T): ArrayStack.this.type

    Does the same as `push`, but returns the updated stack.

    Does the same as `push`, but returns the updated stack.

    x

      The element to push.

    returns

      A reference to this stack.

    Definition Classes
      ArrayStack → Builder → Growable

11. #### def +=(elem1: T, elem2: T, elems: T*): ArrayStack.this.type

    adds two or more elements to this array stack.

    adds two or more elements to this array stack.

    elem1

      the first element to add.

    elem2

      the second element to add.

    elems

      the remaining elements to add.

    returns

      the array stack itself

    Definition Classes
      Growable

12. #### def ->[B](y: B): (ArrayStack[T], B)

    Implicit information
      This member is added by an implicit conversion from ArrayStack[T] to ArrowAssoc[ArrayStack[T]] performed by method any2ArrowAssoc in scala.Predef.
    Definition Classes
      ArrowAssoc
    Annotations
      @inline()

13. #### def /:[B](z: B)(op: (B, T) ⇒ B): B

    Applies a binary operator to a start value and all elements of this array stack, going left to right.

    Applies a binary operator to a start value and all elements of this array stack, going left to right.

    Note: `/:` is alternate syntax for `foldLeft`; `z /: xs` is the same as `xs foldLeft z`.

    Examples:

    Note that the folding function used to compute b is equivalent to that used to compute c.

        scala> val a = LinkedList(1,2,3,4)
        a: scala.collection.mutable.LinkedList[Int] = LinkedList(1, 2, 3, 4)

        scala> val b = (5 /: a)(_+_)
        b: Int = 15

        scala> val c = (5 /: a)((x,y) => x + y)
        c: Int = 15

    B

      the result type of the binary operator.

    z

      the start value.

    op

      the binary operator.

    returns

      the result of inserting `op` between consecutive elements of this array stack, going left to right with the start value `z` on the left:

          op(...op(op(z, x_1), x_2), ..., x_n)

      where `x1, ..., xn` are the elements of this array stack.

    Definition Classes
      TraversableOnce → GenTraversableOnce

14. #### def :+(elem: A): ArrayStack[A]

    [use case] A copy of this array stack with an element appended.

    [use case]

    A copy of this array stack with an element appended.

    A mnemonic for `+:` vs. `:+` is: the COLon goes on the COLlection side.

    Example:

        scala> import scala.collection.mutable.LinkedList
        import scala.collection.mutable.LinkedList

        scala> val a = LinkedList(1)
        a: scala.collection.mutable.LinkedList[Int] = LinkedList(1)

        scala> val b = a :+ 2
        b: scala.collection.mutable.LinkedList[Int] = LinkedList(1, 2)

        scala> println(a)
        LinkedList(1)

    elem

      the appended element

    returns

      a new array stack consisting of all elements of this array stack followed by `elem`.

    Definition Classes
      SeqLike → GenSeqLike
    Full Signature

    #### def :+[B >: T, That](elem: B)(implicit bf: CanBuildFrom[ArrayStack[T], B, That]): That

15. #### def :\[B](z: B)(op: (T, B) ⇒ B): B

    Applies a binary operator to all elements of this array stack and a start value, going right to left.

    Applies a binary operator to all elements of this array stack and a start value, going right to left.

    Note: `:\` is alternate syntax for `foldRight`; `xs :\ z` is the same as `xs foldRight z`.

    Examples:

    Note that the folding function used to compute b is equivalent to that used to compute c.

        scala> val a = LinkedList(1,2,3,4)
        a: scala.collection.mutable.LinkedList[Int] = LinkedList(1, 2, 3, 4)

        scala> val b = (a :\ 5)(_+_)
        b: Int = 15

        scala> val c = (a :\ 5)((x,y) => x + y)
        c: Int = 15

    B

      the result type of the binary operator.

    z

      the start value

    op

      the binary operator

    returns

      the result of inserting `op` between consecutive elements of this array stack, going right to left with the start value `z` on the right:

          op(x_1, op(x_2, ... op(x_n, z)...))

      where `x1, ..., xn` are the elements of this array stack.

    Definition Classes
      TraversableOnce → GenTraversableOnce

16. #### final def ==(arg0: AnyRef): Boolean

    Definition Classes
      AnyRef

17. #### final def ==(arg0: Any): Boolean

    Test two objects for equality.

    Test two objects for equality. The expression `x == that` is equivalent to `if (x eq null) that eq null else x.equals(that)`.

    returns

      `true` if the receiver object is equivalent to the argument; `false` otherwise.

    Definition Classes
      Any

18. #### def addString(b: scala.StringBuilder): scala.StringBuilder

    Appends all elements of this array stack to a string builder.

    Appends all elements of this array stack to a string builder. The written text consists of the string representations (w.r.t. the method `toString`) of all elements of this array stack without any separator string.

    Example:

        scala> val a = LinkedList(1,2,3,4)
        a: scala.collection.mutable.LinkedList[Int] = LinkedList(1, 2, 3, 4)

        scala> val b = new StringBuilder()
        b: StringBuilder =

        scala> val h = a.addString(b)
        b: StringBuilder = 1234

    b

      the string builder to which elements are appended.

    returns

      the string builder `b` to which elements were appended.

    Definition Classes
      TraversableOnce

19. #### def addString(b: scala.StringBuilder, sep: String): scala.StringBuilder

    Appends all elements of this array stack to a string builder using a separator string.

    Appends all elements of this array stack to a string builder using a separator string. The written text consists of the string representations (w.r.t. the method `toString`) of all elements of this array stack, separated by the string `sep`.

    Example:

        scala> val a = LinkedList(1,2,3,4)
        a: scala.collection.mutable.LinkedList[Int] = LinkedList(1, 2, 3, 4)

        scala> val b = new StringBuilder()
        b: StringBuilder =

        scala> a.addString(b, ", ")
        res0: StringBuilder = 1, 2, 3, 4

    b

      the string builder to which elements are appended.

    sep

      the separator string.

    returns

      the string builder `b` to which elements were appended.

    Definition Classes
      TraversableOnce

20. #### def addString(b: scala.StringBuilder, start: String, sep: String, end: String): scala.StringBuilder

    Appends all elements of this array stack to a string builder using start, end, and separator strings.

    Appends all elements of this array stack to a string builder using start, end, and separator strings. The written text begins with the string `start` and ends with the string `end`. Inside, the string representations (w.r.t. the method `toString`) of all elements of this array stack are separated by the string `sep`.

    Example:

        scala> val a = LinkedList(1,2,3,4)
        a: scala.collection.mutable.LinkedList[Int] = LinkedList(1, 2, 3, 4)

        scala> val b = new StringBuilder()
        b: StringBuilder =

        scala> a.addString(b, "LinkedList(", ", ", ")")
        res1: StringBuilder = LinkedList(1, 2, 3, 4)

    b

      the string builder to which elements are appended.

    start

      the starting string.

    sep

      the separator string.

    end

      the ending string.

    returns

      the string builder `b` to which elements were appended.

    Definition Classes
      TraversableOnce

21. #### def aggregate[B](z: B)(seqop: (B, T) ⇒ B, combop: (B, B) ⇒ B): B

    Aggregates the results of applying an operator to subsequent elements.

    Aggregates the results of applying an operator to subsequent elements.

    This is a more general form of `fold` and `reduce`. It has similar semantics, but does not require the result to be a supertype of the element type. It traverses the elements in different partitions sequentially, using `seqop` to update the result, and then applies `combop` to results from different partitions. The implementation of this operation may operate on an arbitrary number of collection partitions, so `combop` may be invoked an arbitrary number of times.

    For example, one might want to process some elements and then produce a `Set`. In this case, `seqop` would process an element and append it to the list, while `combop` would concatenate two lists from different partitions together. The initial value `z` would be an empty set.

        pc.aggregate(Set[Int]())(_ += process(_), _ ++ _)

    Another example is calculating geometric mean from a collection of doubles (one would typically require big doubles for this).

    B

      the type of accumulated results

    z

      the initial value for the accumulated result of the partition - this will typically be the neutral element for the `seqop` operator (e.g. `Nil` for list concatenation or `0` for summation)

    seqop

      an operator used to accumulate results within a partition

    combop

      an associative operator used to combine results from different partitions

    Definition Classes
      TraversableOnce → GenTraversableOnce

22. #### def andThen[C](k: (T) ⇒ C): PartialFunction[Int, C]

    Composes this partial function with a transformation function that gets applied to results of this partial function.

    Composes this partial function with a transformation function that gets applied to results of this partial function.

    C

      the result type of the transformation function.

    k

      the transformation function

    returns

      a partial function with the same domain as this partial function, which maps arguments `x` to `k(this(x))`.

    Definition Classes
      PartialFunction → Function1

23. #### def apply(n: Int): T

    Retrieve n'th element from stack, where top of stack has index 0.

    Retrieve n'th element from stack, where top of stack has index 0.

    This is a constant time operation.

    n

      the index of the element to return

    returns

      the element at the specified index

    Definition Classes
      ArrayStack → SeqLike → GenSeqLike → Function1
    Exceptions thrown
      IndexOutOfBoundsException

      if the index is out of bounds

24. #### def applyOrElse[A1 <: Int, B1 >: T](x: A1, default: (A1) ⇒ B1): B1

    Applies this partial function to the given argument when it is contained in the function domain.

    Applies this partial function to the given argument when it is contained in the function domain. Applies fallback function where this partial function is not defined.

    Note that expression `pf.applyOrElse(x, default)` is equivalent to

        if(pf isDefinedAt x) pf(x) else default(x)

    except that `applyOrElse` method can be implemented more efficiently. For all partial function literals compiler generates `applyOrElse` implementation which avoids double evaluation of pattern matchers and guards. This makes `applyOrElse` the basis for the efficient implementation for many operations and scenarios, such as:

    - combining partial functions into `orElse`/`andThen` chains does not lead to excessive `apply`/`isDefinedAt` evaluation
    - `lift` and `unlift` do not evaluate source functions twice on each invocation
    - `runWith` allows efficient imperative-style combining of partial functions with conditionally applied actions

    For non-literal partial function classes with nontrivial `isDefinedAt` method it is recommended to override `applyOrElse` with custom implementation that avoids double `isDefinedAt` evaluation. This may result in better performance and more predictable behavior w.r.t. side effects.

    x

      the function argument

    default

      the fallback function

    returns

      the result of this function or fallback function application.

    Definition Classes
      PartialFunction
    Since

      2.10

25. #### final def asInstanceOf[T0]: T0

    Cast the receiver object to be of type `T0`.

    Cast the receiver object to be of type `T0`.

    Note that the success of a cast at runtime is modulo Scala's erasure semantics. Therefore the expression `1.asInstanceOf[String]` will throw a `ClassCastException` at runtime, while the expression `List(1).asInstanceOf[List[String]]` will not. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the requested type.

    returns

      the receiver object.

    Definition Classes
      Any
    Exceptions thrown
      ClassCastException

      if the receiver object is not an instance of the erasure of type `T0`.

26. #### def asParIterable: ParIterable[T]

    Implicit information
      This member is added by an implicit conversion from ArrayStack[T] to TraversableOps[T] performed by method traversable2ops in scala.collection.parallel.
    Definition Classes
      TraversableOps

27. #### def asParSeq: ParSeq[T]

    Implicit information
      This member is added by an implicit conversion from ArrayStack[T] to TraversableOps[T] performed by method traversable2ops in scala.collection.parallel.
    Definition Classes
      TraversableOps

28. #### def canEqual(that: Any): Boolean

    Method called from equality methods, so that user-defined subclasses can refuse to be equal to other collections of the same kind.

    Method called from equality methods, so that user-defined subclasses can refuse to be equal to other collections of the same kind.

    that

      The object with which this array stack should be compared

    returns

      `true`, if this array stack can possibly equal `that`, `false` otherwise. The test takes into consideration only the run-time types of objects but ignores their elements.

    Definition Classes
      IterableLike → Equals

29. #### def clear(): Unit

    Empties the stack.

    Empties the stack.

    Definition Classes
      ArrayStack → Builder → Growable → Clearable

30. #### def clone(): ArrayStack[T]

    Create a copy of the receiver object.

    Create a copy of the receiver object.

    The default implementation of the `clone` method is platform dependent.

    returns

      a copy of the receiver object.

    Definition Classes
      ArrayStack → Cloneable → AnyRef
    Note

      not specified by SLS as a member of AnyRef

31. #### def collect[B](pf: PartialFunction[A, B]): ArrayStack[B]

    [use case] Builds a new collection by applying a partial function to all elements of this array stack on which the function is defined.

    [use case]

    Builds a new collection by applying a partial function to all elements of this array stack on which the function is defined.

    B

      the element type of the returned collection.

    pf

      the partial function which filters and maps the array stack.

    returns

      a new array stack resulting from applying the given partial function `pf` to each element on which it is defined and collecting the results. The order of the elements is preserved.

    Definition Classes
      TraversableLike → GenTraversableLike
    Full Signature

    #### def collect[B, That](pf: PartialFunction[T, B])(implicit bf: CanBuildFrom[ArrayStack[T], B, That]): That

32. #### def collectFirst[B](pf: PartialFunction[T, B]): Option[B]

    Finds the first element of the array stack for which the given partial function is defined, and applies the partial function to it.

    Finds the first element of the array stack for which the given partial function is defined, and applies the partial function to it.

    pf

      the partial function

    returns

      an option value containing pf applied to the first value for which it is defined, or `None` if none exists.

    Definition Classes
      TraversableOnce
    Example:

    1. `Seq("a", 1, 5L).collectFirst({ case x: Int => x*10 }) = Some(10)`

33. #### def combinations(n: Int): Iterator[ArrayStack[T]]

    Iterates over combinations.

    Iterates over combinations.

    returns

      An Iterator which traverses the possible n-element combinations of this array stack.

    Definition Classes
      SeqLike
    Example:

    1. `"abbbc".combinations(2) = Iterator(ab, ac, bb, bc)`

34. #### def combine(f: (T, T) ⇒ T): Unit

    Pop the top two elements off the stack, apply `f` to them and push the result back on to the stack.

    Pop the top two elements off the stack, apply `f` to them and push the result back on to the stack.

    This function will throw an exception if stack contains fewer than 2 elements.

    f

      The function to apply to the top two elements.

35. #### def companion: ArrayStack.type

    The factory companion object that builds instances of class `ArrayStack`.

    The factory companion object that builds instances of class `ArrayStack`. (or its `Iterable` superclass where class `ArrayStack` is not a `Seq`.)

    Definition Classes
      ArrayStack → Seq → Iterable → Traversable → Seq → GenSeq → Iterable → GenIterable → Traversable → GenTraversable → GenericTraversableTemplate

36. #### def compose[A](g: (A) ⇒ Int): (A) ⇒ T

    Composes two instances of Function1 in a new Function1, with this function applied last.

    Composes two instances of Function1 in a new Function1, with this function applied last.

    A

      the type to which function `g` can be applied

    g

      a function A => T1

    returns

      a new function `f` such that `f(x) == apply(g(x))`

    Definition Classes
      Function1
    Annotations
      @unspecialized()

37. #### def contains(elem: Any): Boolean

    Tests whether this array stack contains a given value as an element.

    Tests whether this array stack contains a given value as an element.

    elem

      the element to test.

    returns

      `true` if this array stack has an element that is equal (as determined by `==`) to `elem`, `false` otherwise.

    Definition Classes
      SeqLike

38. #### def containsSlice[B](that: GenSeq[B]): Boolean

    Tests whether this array stack contains a given sequence as a slice.

    Tests whether this array stack contains a given sequence as a slice.

    that

      the sequence to test

    returns

      `true` if this array stack contains a slice with the same elements as `that`, otherwise `false`.

    Definition Classes
      SeqLike

39. #### def copyToArray(xs: Array[A], start: Int, len: Int): Unit

    [use case] Copies elements of this array stack to an array.

    [use case]

    Copies elements of this array stack to an array. Fills the given array `xs` with at most `len` elements of this array stack, starting at position `start`. Copying will stop once either the end of the current array stack is reached, or the end of the array is reached, or `len` elements have been copied.

    xs

      the array to fill.

    start

      the starting index.

    len

      the maximal number of elements to copy.

    Definition Classes
      IterableLike → TraversableLike → TraversableOnce → GenTraversableOnce
    Full Signature

    #### def copyToArray[B >: T](xs: Array[B], start: Int, len: Int): Unit

40. #### def copyToArray(xs: Array[A]): Unit

    [use case] Copies values of this array stack to an array.

    [use case]

    Copies values of this array stack to an array. Fills the given array `xs` with values of this array stack. Copying will stop once either the end of the current array stack is reached, or the end of the array is reached.

    xs

      the array to fill.

    Definition Classes
      TraversableOnce → GenTraversableOnce
    Full Signature

    #### def copyToArray[B >: T](xs: Array[B]): Unit

41. #### def copyToArray(xs: Array[A], start: Int): Unit

    [use case] Copies values of this array stack to an array.

    [use case]

    Copies values of this array stack to an array. Fills the given array `xs` with values of this array stack, beginning at index `start`. Copying will stop once either the end of the current array stack is reached, or the end of the array is reached.

    xs

      the array to fill.

    start

      the starting index.

    Definition Classes
      TraversableOnce → GenTraversableOnce
    Full Signature

    #### def copyToArray[B >: T](xs: Array[B], start: Int): Unit

42. #### def copyToBuffer[B >: T](dest: Buffer[B]): Unit

    Copies all elements of this array stack to a buffer.

    Copies all elements of this array stack to a buffer.

    dest

      The buffer to which elements are copied.

    Definition Classes
      TraversableOnce

43. #### def corresponds[B](that: GenSeq[B])(p: (T, B) ⇒ Boolean): Boolean

    Tests whether every element of this array stack relates to the corresponding element of another sequence by satisfying a test predicate.

    Tests whether every element of this array stack relates to the corresponding element of another sequence by satisfying a test predicate.

    B

      the type of the elements of `that`

    that

      the other sequence

    p

      the test predicate, which relates elements from both sequences

    returns

      `true` if both sequences have the same length and `p(x, y)` is `true` for all corresponding elements `x` of this array stack and `y` of `that`, otherwise `false`.

    Definition Classes
      SeqLike → GenSeqLike

44. #### def count(p: (T) ⇒ Boolean): Int

    Counts the number of elements in the array stack which satisfy a predicate.

    Counts the number of elements in the array stack which satisfy a predicate.

    p

      the predicate used to test elements.

    returns

      the number of elements satisfying the predicate `p`.

    Definition Classes
      TraversableOnce → GenTraversableOnce

45. #### def diff(that: collection.Seq[T]): ArrayStack[T]

    [use case] Computes the multiset difference between this array stack and another sequence.

    [use case]

    Computes the multiset difference between this array stack and another sequence.

    that

      the sequence of elements to remove

    returns

      a new array stack which contains all elements of this array stack except some of occurrences of elements that also appear in `that`. If an element value `x` appears n times in `that`, then the first n occurrences of `x` will not form part of the result, but any following occurrences will.

    Definition Classes
      SeqLike → GenSeqLike
    Full Signature

    #### def diff[B >: T](that: GenSeq[B]): ArrayStack[T]

46. #### def distinct: ArrayStack[T]

    Builds a new array stack from this array stack without any duplicate elements.

    Builds a new array stack from this array stack without any duplicate elements.

    returns

      A new array stack which contains the first occurrence of every element of this array stack.

    Definition Classes
      SeqLike → GenSeqLike

47. #### def drain(f: (T) ⇒ Unit): Unit

    Empties the stack, passing all elements on it in LIFO order to the provided function.

    Empties the stack, passing all elements on it in LIFO order to the provided function.

    f

      The function to drain to.

48. #### def drop(n: Int): ArrayStack[T]

    Selects all elements except first n ones.

    Selects all elements except first n ones.

    n

      the number of elements to drop from this array stack.

    returns

      a array stack consisting of all elements of this array stack except the first `n` ones, or else the empty array stack, if this array stack has less than `n` elements.

    Definition Classes
      IterableLike → TraversableLike → GenTraversableLike

49. #### def dropRight(n: Int): ArrayStack[T]

    Selects all elements except last n ones.

    Selects all elements except last n ones.

    n

      The number of elements to take

    returns

      a array stack consisting of all elements of this array stack except the last `n` ones, or else the empty array stack, if this array stack has less than `n` elements.

    Definition Classes
      IterableLike

50. #### def dropWhile(p: (T) ⇒ Boolean): ArrayStack[T]

    Drops longest prefix of elements that satisfy a predicate.

    Drops longest prefix of elements that satisfy a predicate.

    returns

      the longest suffix of this array stack whose first element does not satisfy the predicate `p`.

    Definition Classes
      TraversableLike → GenTraversableLike

51. #### def dup(): Unit

    Duplicate the top element of the stack.

    Duplicate the top element of the stack.

    After calling this method, the stack will have an additional element at the top equal to the element that was previously at the top. If the stack is empty, an exception is thrown.

52. #### def endsWith[B](that: GenSeq[B]): Boolean

    Tests whether this array stack ends with the given sequence.

    Tests whether this array stack ends with the given sequence.

    that

      the sequence to test

    returns

      `true` if this array stack has `that` as a suffix, `false` otherwise.

    Definition Classes
      SeqLike → GenSeqLike

53. #### def ensuring(cond: (ArrayStack[T]) ⇒ Boolean, msg: ⇒ Any): ArrayStack[T]

    Implicit information
      This member is added by an implicit conversion from ArrayStack[T] to Ensuring[ArrayStack[T]] performed by method any2Ensuring in scala.Predef.
    Definition Classes
      Ensuring

54. #### def ensuring(cond: (ArrayStack[T]) ⇒ Boolean): ArrayStack[T]

    Implicit information
      This member is added by an implicit conversion from ArrayStack[T] to Ensuring[ArrayStack[T]] performed by method any2Ensuring in scala.Predef.
    Definition Classes
      Ensuring

55. #### def ensuring(cond: Boolean, msg: ⇒ Any): ArrayStack[T]

    Implicit information
      This member is added by an implicit conversion from ArrayStack[T] to Ensuring[ArrayStack[T]] performed by method any2Ensuring in scala.Predef.
    Definition Classes
      Ensuring

56. #### def ensuring(cond: Boolean): ArrayStack[T]

    Implicit information
      This member is added by an implicit conversion from ArrayStack[T] to Ensuring[ArrayStack[T]] performed by method any2Ensuring in scala.Predef.
    Definition Classes
      Ensuring

57. #### final def eq(arg0: AnyRef): Boolean

    Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

    Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

    The `eq` method implements an equivalence relation on non-null instances of `AnyRef`, and has three additional properties:

    - It is consistent: for any non-null instances `x` and `y` of type `AnyRef`, multiple invocations of `x.eq(y)` consistently returns `true` or consistently returns `false`.
    - For any non-null instance `x` of type `AnyRef`, `x.eq(null)` and `null.eq(x)` returns `false`.
    - `null.eq(null)` returns `true`.

    When overriding the `equals` or `hashCode` methods, it is important to ensure that their behavior is consistent with reference equality. Therefore, if two objects are references to each other (`o1 eq o2`), they should be equal to each other (`o1 == o2`) and they should hash to the same value (`o1.hashCode == o2.hashCode`).

    returns

      `true` if the argument is a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

58. #### def equals(that: Any): Boolean

    The equals method for arbitrary sequences.

    The equals method for arbitrary sequences. Compares this sequence to some other object.

    that

      The object to compare the sequence to

    returns

      `true` if `that` is a sequence that has the same elements as this sequence in the same order, `false` otherwise

    Definition Classes
      GenSeqLike → Equals → Any

59. #### def exists(p: (T) ⇒ Boolean): Boolean

    Tests whether a predicate holds for some of the elements of this array stack.

    Tests whether a predicate holds for some of the elements of this array stack.

    p

      the predicate used to test elements.

    returns

      `true` if the given predicate `p` holds for some of the elements of this array stack, otherwise `false`.

    Definition Classes
      IterableLike → TraversableLike → TraversableOnce → GenTraversableOnce

60. #### def filter(p: (T) ⇒ Boolean): ArrayStack[T]

    Selects all elements of this array stack which satisfy a predicate.

    Selects all elements of this array stack which satisfy a predicate.

    p

      the predicate used to test elements.

    returns

      a new array stack consisting of all elements of this array stack that satisfy the given predicate `p`. The order of the elements is preserved.

    Definition Classes
      TraversableLike → GenTraversableLike

61. #### def filterNot(p: (T) ⇒ Boolean): ArrayStack[T]

    Selects all elements of this array stack which do not satisfy a predicate.

    Selects all elements of this array stack which do not satisfy a predicate.

    p

      the predicate used to test elements.

    returns

      a new array stack consisting of all elements of this array stack that do not satisfy the given predicate `p`. The order of the elements is preserved.

    Definition Classes
      TraversableLike → GenTraversableLike

62. #### def finalize(): Unit

    Called by the garbage collector on the receiver object when there are no more references to the object.

    Called by the garbage collector on the receiver object when there are no more references to the object.

    The details of when and if the `finalize` method is invoked, as well as the interaction between `finalize` and non-local returns and exceptions, are all platform dependent.

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( classOf[java.lang.Throwable] )
    Note

      not specified by SLS as a member of AnyRef

63. #### def find(p: (T) ⇒ Boolean): Option[T]

    Finds the first element of the array stack satisfying a predicate, if any.

    Finds the first element of the array stack satisfying a predicate, if any.

    p

      the predicate used to test elements.

    returns

      an option value containing the first element in the array stack that satisfies `p`, or `None` if none exists.

    Definition Classes
      IterableLike → TraversableLike → TraversableOnce → GenTraversableOnce

64. #### def flatMap[B](f: (A) ⇒ GenTraversableOnce[B]): ArrayStack[B]

    [use case] Builds a new collection by applying a function to all elements of this array stack and using the elements of the resulting collections.

    [use case]

    Builds a new collection by applying a function to all elements of this array stack and using the elements of the resulting collections.

    For example:

        def getWords(lines: Seq[String]): Seq[String] = lines flatMap (line => line split "\\W+")

    The type of the resulting collection is guided by the static type of array stack. This might cause unexpected results sometimes. For example:

        // lettersOf will return a Seq[Char] of likely repeated letters, instead of a Set
        def lettersOf(words: Seq[String]) = words flatMap (word => word.toSet)

        // lettersOf will return a Set[Char], not a Seq
        def lettersOf(words: Seq[String]) = words.toSet flatMap (word => word.toSeq)

        // xs will be a an Iterable[Int]
        val xs = Map("a" -> List(11,111), "b" -> List(22,222)).flatMap(_._2)

        // ys will be a Map[Int, Int]
        val ys = Map("a" -> List(1 -> 11,1 -> 111), "b" -> List(2 -> 22,2 -> 222)).flatMap(_._2)

    B

      the element type of the returned collection.

    f

      the function to apply to each element.

    returns

      a new array stack resulting from applying the given collection-valued function `f` to each element of this array stack and concatenating the results.

    Definition Classes
      TraversableLike → GenTraversableLike → FilterMonadic
    Full Signature

    #### def flatMap[B, That](f: (T) ⇒ GenTraversableOnce[B])(implicit bf: CanBuildFrom[ArrayStack[T], B, That]): That

65. #### def flatten[B]: ArrayStack[B]

    [use case] Converts this array stack of traversable collections into a array stack formed by the elements of these traversable collections.

    [use case]

    Converts this array stack of traversable collections into a array stack formed by the elements of these traversable collections.

    The resulting collection's type will be guided by the static type of array stack. For example:

        val xs = List(Set(1, 2, 3), Set(1, 2, 3))
        // xs == List(1, 2, 3, 1, 2, 3)

        val ys = Set(List(1, 2, 3), List(3, 2, 1))
        // ys == Set(1, 2, 3)

    B

      the type of the elements of each traversable collection.

    returns

      a new array stack resulting from concatenating all element array stacks.

    Definition Classes
      GenericTraversableTemplate
    Full Signature

    #### def flatten[B](implicit asTraversable: (T) ⇒ GenTraversableOnce[B]): ArrayStack[B]

66. #### def fold[A1 >: T](z: A1)(op: (A1, A1) ⇒ A1): A1

    Folds the elements of this array stack using the specified associative binary operator.

    Folds the elements of this array stack using the specified associative binary operator.

    The order in which operations are performed on elements is unspecified and may be nondeterministic.

    A1

      a type parameter for the binary operator, a supertype of `A`.

    z

      a neutral element for the fold operation; may be added to the result an arbitrary number of times, and must not change the result (e.g., `Nil` for list concatenation, 0 for addition, or 1 for multiplication.)

    op

      a binary operator that must be associative

    returns

      the result of applying fold operator `op` between all the elements and `z`

    Definition Classes
      TraversableOnce → GenTraversableOnce

67. #### def foldLeft[B](z: B)(op: (B, T) ⇒ B): B

    Applies a binary operator to a start value and all elements of this array stack, going left to right.

    Applies a binary operator to a start value and all elements of this array stack, going left to right.

    B

      the result type of the binary operator.

    z

      the start value.

    op

      the binary operator.

    returns

      the result of inserting `op` between consecutive elements of this array stack, going left to right with the start value `z` on the left:

          op(...op(z, x_1), x_2, ..., x_n)

      where `x1, ..., xn` are the elements of this array stack.

    Definition Classes
      TraversableOnce → GenTraversableOnce

68. #### def foldRight[B](z: B)(op: (T, B) ⇒ B): B

    Applies a binary operator to all elements of this array stack and a start value, going right to left.

    Applies a binary operator to all elements of this array stack and a start value, going right to left.

    B

      the result type of the binary operator.

    z

      the start value.

    op

      the binary operator.

    returns

      the result of inserting `op` between consecutive elements of this array stack, going right to left with the start value `z` on the right:

          op(x_1, op(x_2, ... op(x_n, z)...))

      where `x1, ..., xn` are the elements of this array stack.

    Definition Classes
      IterableLike → TraversableOnce → GenTraversableOnce

69. #### def forall(p: (T) ⇒ Boolean): Boolean

    Tests whether a predicate holds for all elements of this array stack.

    Tests whether a predicate holds for all elements of this array stack.

    p

      the predicate used to test elements.

    returns

      `true` if the given predicate `p` holds for all elements of this array stack, otherwise `false`.

    Definition Classes
      IterableLike → TraversableLike → TraversableOnce → GenTraversableOnce

70. #### def foreach(f: (A) ⇒ Unit): Unit

    [use case] Applies a function `f` to all elements of this array stack.

    [use case]

    Applies a function `f` to all elements of this array stack.

    Note: this method underlies the implementation of most other bulk operations. Subclasses should re-implement this method if a more efficient implementation exists.

    f

      the function that is applied for its side-effect to every element. The result of function `f` is discarded.

    Definition Classes
      ArrayStack → IterableLike → GenericTraversableTemplate → TraversableLike → GenTraversableLike → TraversableOnce → GenTraversableOnce → FilterMonadic
    Full Signature

    #### def foreach[U](f: (T) ⇒ U): Unit

71. #### def formatted(fmtstr: String): String

    Returns string formatted according to given `format` string.

    Returns string formatted according to given `format` string. Format strings are as for `String.format` (@see java.lang.String.format).

    Implicit information
      This member is added by an implicit conversion from ArrayStack[T] to StringFormat performed by method any2stringfmt in scala.Predef.
    Definition Classes
      StringFormat
    Annotations
      @inline()

72. #### def genericBuilder[B]: Builder[B, ArrayStack[B]]

    The generic builder that builds instances of `ArrayStack` at arbitrary element types.

    The generic builder that builds instances of `ArrayStack` at arbitrary element types.

    Definition Classes
      GenericTraversableTemplate

73. #### final def getClass(): Class[_]

    A representation that corresponds to the dynamic class of the receiver object.

    A representation that corresponds to the dynamic class of the receiver object.

    The nature of the representation is platform dependent.

    returns

      a representation that corresponds to the dynamic class of the receiver object.

    Definition Classes
      AnyRef → Any
    Note

      not specified by SLS as a member of AnyRef

74. #### def groupBy[K](f: (T) ⇒ K): immutable.Map[K, ArrayStack[T]]

    Partitions this array stack into a map of array stacks according to some discriminator function.

    Partitions this array stack into a map of array stacks according to some discriminator function.

    Note: this method is not re-implemented by views. This means when applied to a view it will always force the view and return a new array stack.

    K

      the type of keys returned by the discriminator function.

    f

      the discriminator function.

    returns

      A map from keys to array stacks such that the following invariant holds:

          (xs partition f)(k) = xs filter (x => f(x) == k)

      That is, every key `k` is bound to a array stack of those elements `x` for which `f(x)` equals `k`.

    Definition Classes
      TraversableLike → GenTraversableLike

75. #### def grouped(size: Int): Iterator[ArrayStack[T]]

    Partitions elements in fixed size array stacks.

    Partitions elements in fixed size array stacks.

    size

      the number of elements per group

    returns

      An iterator producing array stacks of size `size`, except the last will be truncated if the elements don't divide evenly.

    Definition Classes
      IterableLike
    See also

      scala.collection.Iterator, method `grouped`

76. #### def hasDefiniteSize: Boolean

    Tests whether this array stack is known to have a finite size.

    Tests whether this array stack is known to have a finite size. All strict collections are known to have finite size. For a non-strict collection such as `Stream`, the predicate returns `true` if all elements have been computed. It returns `false` if the stream is not yet evaluated to the end.

    Note: many collection methods will not work on collections of infinite sizes.

    returns

      `true` if this collection is known to have finite size, `false` otherwise.

    Definition Classes
      TraversableLike → TraversableOnce → GenTraversableOnce

77. #### def hashCode(): Int

    Hashcodes for `ArrayStack` produce a value from the hashcodes of all the elements of the array stack.

    Hashcodes for `ArrayStack` produce a value from the hashcodes of all the elements of the array stack.

    returns

      the hash code value for this object.

    Definition Classes
      GenSeqLike → Any

78. #### def head: T

    Selects the first element of this array stack.

    Selects the first element of this array stack.

    returns

      the first element of this array stack.

    Definition Classes
      IterableLike → TraversableLike → GenTraversableLike
    Exceptions thrown
      `NoSuchElementException`

      if the array stack is empty.

79. #### def headOption: Option[T]

    Optionally selects the first element.

    Optionally selects the first element.

    returns

      the first element of this array stack if it is nonempty, `None` if it is empty.

    Definition Classes
      TraversableLike → GenTraversableLike

80. #### def ifParSeq[R](isbody: (ParSeq[T]) ⇒ R): (TraversableOps[T])#Otherwise[R]

    Implicit information
      This member is added by an implicit conversion from ArrayStack[T] to TraversableOps[T] performed by method traversable2ops in scala.collection.parallel.
    Definition Classes
      TraversableOps

81. #### def indexOf(elem: T, from: Int): Int

    [use case] Finds index of first occurrence of some value in this array stack after or at some start index.

    [use case]

    Finds index of first occurrence of some value in this array stack after or at some start index.

    elem

      the element value to search for.

    from

      the start index

    returns

      the index `>= from` of the first element of this array stack that is equal (as determined by `==`) to `elem`, or `-1`, if none exists.

    Definition Classes
      GenSeqLike
    Full Signature

    #### def indexOf[B >: T](elem: B, from: Int): Int

82. #### def indexOf(elem: T): Int

    [use case] Finds index of first occurrence of some value in this array stack.

    [use case]

    Finds index of first occurrence of some value in this array stack.

    elem

      the element value to search for.

    returns

      the index of the first element of this array stack that is equal (as determined by `==`) to `elem`, or `-1`, if none exists.

    Definition Classes
      GenSeqLike
    Full Signature

    #### def indexOf[B >: T](elem: B): Int

83. #### def indexOfSlice[B >: T](that: GenSeq[B], from: Int): Int

    Finds first index after or at a start index where this array stack contains a given sequence as a slice.

    Finds first index after or at a start index where this array stack contains a given sequence as a slice.

    that

      the sequence to test

    from

      the start index

    returns

      the first index `>= from` such that the elements of this array stack starting at this index match the elements of sequence `that`, or `-1` of no such subsequence exists.

    Definition Classes
      SeqLike

84. #### def indexOfSlice[B >: T](that: GenSeq[B]): Int

    Finds first index where this array stack contains a given sequence as a slice.

    Finds first index where this array stack contains a given sequence as a slice.

    that

      the sequence to test

    returns

      the first index such that the elements of this array stack starting at this index match the elements of sequence `that`, or `-1` of no such subsequence exists.

    Definition Classes
      SeqLike

85. #### def indexWhere(p: (T) ⇒ Boolean, from: Int): Int

    Finds index of the first element satisfying some predicate after or at some start index.

    Finds index of the first element satisfying some predicate after or at some start index.

    p

      the predicate used to test elements.

    from

      the start index

    returns

      the index `>= from` of the first element of this array stack that satisfies the predicate `p`, or `-1`, if none exists.

    Definition Classes
      SeqLike → GenSeqLike

86. #### def indexWhere(p: (T) ⇒ Boolean): Int

    Finds index of first element satisfying some predicate.

    Finds index of first element satisfying some predicate.

    p

      the predicate used to test elements.

    returns

      the index of the first element of this array stack that satisfies the predicate `p`, or `-1`, if none exists.

    Definition Classes
      GenSeqLike

87. #### def indices: immutable.Range

    Produces the range of all indices of this sequence.

    Produces the range of all indices of this sequence.

    returns

      a `Range` value from `0` to one less than the length of this array stack.

    Definition Classes
      SeqLike

88. #### def init: ArrayStack[T]

    Selects all elements except the last.

    Selects all elements except the last.

    returns

      a array stack consisting of all elements of this array stack except the last one.

    Definition Classes
      TraversableLike → GenTraversableLike
    Exceptions thrown
      `UnsupportedOperationException`

      if the array stack is empty.

89. #### def inits: Iterator[ArrayStack[T]]

    Iterates over the inits of this array stack.

    Iterates over the inits of this array stack. The first value will be this array stack and the final one will be an empty array stack, with the intervening values the results of successive applications of `init`.

    returns

      an iterator over all the inits of this array stack

    Definition Classes
      TraversableLike
    Example:

    1. `List(1,2,3).inits = Iterator(List(1,2,3), List(1,2), List(1), Nil)`

90. #### def intersect(that: collection.Seq[T]): ArrayStack[T]

    [use case] Computes the multiset intersection between this array stack and another sequence.

    [use case]

    Computes the multiset intersection between this array stack and another sequence.

    that

      the sequence of elements to intersect with.

    returns

      a new array stack which contains all elements of this array stack which also appear in `that`. If an element value `x` appears n times in `that`, then the first n occurrences of `x` will be retained in the result, but any following occurrences will be omitted.

    Definition Classes
      SeqLike → GenSeqLike
    Full Signature

    #### def intersect[B >: T](that: GenSeq[B]): ArrayStack[T]

91. #### def isDefinedAt(idx: Int): Boolean

    Tests whether this array stack contains given index.

    Tests whether this array stack contains given index.

    The implementations of methods `apply` and `isDefinedAt` turn a `Seq[A]` into a `PartialFunction[Int, A]`.

    idx

      the index to test

    returns

      `true` if this array stack contains an element at position `idx`, `false` otherwise.

    Definition Classes
      GenSeqLike

92. #### def isEmpty: Boolean

    Tests whether this array stack is empty.

    Tests whether this array stack is empty.

    returns

      `true` if the array stack contain no elements, `false` otherwise.

    Definition Classes
      ArrayStack → SeqLike → IterableLike → GenericTraversableTemplate → TraversableLike → TraversableOnce → GenTraversableOnce

93. #### final def isInstanceOf[T0]: Boolean

    Test whether the dynamic type of the receiver object is `T0`.

    Test whether the dynamic type of the receiver object is `T0`.

    Note that the result of the test is modulo Scala's erasure semantics. Therefore the expression `1.isInstanceOf[String]` will return `false`, while the expression `List(1).isInstanceOf[List[String]]` will return `true`. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the specified type.

    returns

      `true` if the receiver object is an instance of erasure of type `T0`; `false` otherwise.

    Definition Classes
      Any

94. #### def isParIterable: Boolean

    Implicit information
      This member is added by an implicit conversion from ArrayStack[T] to TraversableOps[T] performed by method traversable2ops in scala.collection.parallel.
    Definition Classes
      TraversableOps

95. #### def isParSeq: Boolean

    Implicit information
      This member is added by an implicit conversion from ArrayStack[T] to TraversableOps[T] performed by method traversable2ops in scala.collection.parallel.
    Definition Classes
      TraversableOps

96. #### def isParallel: Boolean

    Implicit information
      This member is added by an implicit conversion from ArrayStack[T] to TraversableOps[T] performed by method traversable2ops in scala.collection.parallel.
    Definition Classes
      TraversableOps

97. #### final def isTraversableAgain: Boolean

    Tests whether this array stack can be repeatedly traversed.

    Tests whether this array stack can be repeatedly traversed.

    returns

      `true`

    Definition Classes
      TraversableLike → GenTraversableLike → GenTraversableOnce

98. #### def iterator: Iterator[T]

    Creates and iterator over the stack in LIFO order.

    Creates and iterator over the stack in LIFO order.

    returns

      an iterator over the elements of the stack.

    Definition Classes
      ArrayStack → IterableLike → GenIterableLike

99. #### def last: T

    Selects the last element.

    Selects the last element.

    returns

      The last element of this array stack.

    Definition Classes
      TraversableLike → GenTraversableLike
    Exceptions thrown
      NoSuchElementException

      If the array stack is empty.

100. #### def lastIndexOf(elem: T, end: Int): Int

     [use case] Finds index of last occurrence of some value in this array stack before or at a given end index.

     [use case]

     Finds index of last occurrence of some value in this array stack before or at a given end index.

     elem

       the element value to search for.

     end

       the end index.

     returns

       the index `<= end` of the last element of this array stack that is equal (as determined by `==`) to `elem`, or `-1`, if none exists.

     Definition Classes
       GenSeqLike
     Full Signature

     #### def lastIndexOf[B >: T](elem: B, end: Int): Int

101. #### def lastIndexOf(elem: T): Int

     [use case] Finds index of last occurrence of some value in this array stack.

     [use case]

     Finds index of last occurrence of some value in this array stack.

     elem

       the element value to search for.

     returns

       the index of the last element of this array stack that is equal (as determined by `==`) to `elem`, or `-1`, if none exists.

     Definition Classes
       GenSeqLike
     Full Signature

     #### def lastIndexOf[B >: T](elem: B): Int

102. #### def lastIndexOfSlice[B >: T](that: GenSeq[B], end: Int): Int

     Finds last index before or at a given end index where this array stack contains a given sequence as a slice.

     Finds last index before or at a given end index where this array stack contains a given sequence as a slice.

     that

       the sequence to test

     end

       the end index

     returns

       the last index `<= end` such that the elements of this array stack starting at this index match the elements of sequence `that`, or `-1` of no such subsequence exists.

     Definition Classes
       SeqLike

103. #### def lastIndexOfSlice[B >: T](that: GenSeq[B]): Int

     Finds last index where this array stack contains a given sequence as a slice.

     Finds last index where this array stack contains a given sequence as a slice.

     that

       the sequence to test

     returns

       the last index such that the elements of this array stack starting a this index match the elements of sequence `that`, or `-1` of no such subsequence exists.

     Definition Classes
       SeqLike

104. #### def lastIndexWhere(p: (T) ⇒ Boolean, end: Int): Int

     Finds index of last element satisfying some predicate before or at given end index.

     Finds index of last element satisfying some predicate before or at given end index.

     p

       the predicate used to test elements.

     returns

       the index `<= end` of the last element of this array stack that satisfies the predicate `p`, or `-1`, if none exists.

     Definition Classes
       SeqLike → GenSeqLike

105. #### def lastIndexWhere(p: (T) ⇒ Boolean): Int

     Finds index of last element satisfying some predicate.

     Finds index of last element satisfying some predicate.

     p

       the predicate used to test elements.

     returns

       the index of the last element of this array stack that satisfies the predicate `p`, or `-1`, if none exists.

     Definition Classes
       GenSeqLike

106. #### def lastOption: Option[T]

     Optionally selects the last element.

     Optionally selects the last element.

     returns

       the last element of this array stack$ if it is nonempty, `None` if it is empty.

     Definition Classes
       TraversableLike → GenTraversableLike

107. #### def length: Int

     The number of elements in the stack

     The number of elements in the stack

     returns

       the number of elements in this array stack.

     Definition Classes
       ArrayStack → SeqLike → GenSeqLike

108. #### def lengthCompare(len: Int): Int

     Compares the length of this array stack to a test value.

     Compares the length of this array stack to a test value.

     len

       the test value that gets compared with the length.

     returns

       A value `x` where

           x <  0       if this.length <  len
           x == 0       if this.length == len
           x >  0       if this.length >  len

       The method as implemented here does not call `length` directly; its running time is `O(length min len)` instead of `O(length)`. The method should be overwritten if computing `length` is cheap.

     Definition Classes
       SeqLike

109. #### def lift: (Int) ⇒ Option[T]

     Turns this partial function into a plain function returning an `Option` result.

     Turns this partial function into a plain function returning an `Option` result.

     returns

       a function that takes an argument `x` to `Some(this(x))` if `this` is defined for `x`, and to `None` otherwise.

     Definition Classes
       PartialFunction
     See also

       Function.unlift

110. #### def map[B](f: (A) ⇒ B): ArrayStack[B]

     [use case] Builds a new collection by applying a function to all elements of this array stack.

     [use case]

     Builds a new collection by applying a function to all elements of this array stack.

     B

       the element type of the returned collection.

     f

       the function to apply to each element.

     returns

       a new array stack resulting from applying the given function `f` to each element of this array stack and collecting the results.

     Definition Classes
       TraversableLike → GenTraversableLike → FilterMonadic
     Full Signature

     #### def map[B, That](f: (T) ⇒ B)(implicit bf: CanBuildFrom[ArrayStack[T], B, That]): That

111. #### def mapResult[NewTo](f: (ArrayStack[T]) ⇒ NewTo): Builder[T, NewTo]

     Creates a new builder by applying a transformation function to the results of this builder.

     Creates a new builder by applying a transformation function to the results of this builder.

     NewTo

       the type of collection returned by `f`.

     f

       the transformation function.

     returns

       a new builder which is the same as the current builder except that a transformation function is applied to this builder's result.

     Definition Classes
       Builder

112. #### def max: A

     [use case] Finds the largest element.

     [use case]

     Finds the largest element.

     returns

       the largest element of this array stack.

     Definition Classes
       TraversableOnce → GenTraversableOnce
     Full Signature

     #### def max[B >: T](implicit cmp: Ordering[B]): T

113. #### def maxBy[B](f: (T) ⇒ B)(implicit cmp: Ordering[B]): T

     Definition Classes
       TraversableOnce → GenTraversableOnce

114. #### def min: A

     [use case] Finds the smallest element.

     [use case]

     Finds the smallest element.

     returns

       the smallest element of this array stack

     Definition Classes
       TraversableOnce → GenTraversableOnce
     Full Signature

     #### def min[B >: T](implicit cmp: Ordering[B]): T

115. #### def minBy[B](f: (T) ⇒ B)(implicit cmp: Ordering[B]): T

     Definition Classes
       TraversableOnce → GenTraversableOnce

116. #### def mkString: String

     Displays all elements of this array stack in a string.

     Displays all elements of this array stack in a string.

     returns

       a string representation of this array stack. In the resulting string the string representations (w.r.t. the method `toString`) of all elements of this array stack follow each other without any separator string.

     Definition Classes
       TraversableOnce → GenTraversableOnce

117. #### def mkString(sep: String): String

     Displays all elements of this array stack in a string using a separator string.

     Displays all elements of this array stack in a string using a separator string.

     sep

       the separator string.

     returns

       a string representation of this array stack. In the resulting string the string representations (w.r.t. the method `toString`) of all elements of this array stack are separated by the string `sep`.

     Definition Classes
       TraversableOnce → GenTraversableOnce
     Example:

     1. `List(1, 2, 3).mkString("|") = "1|2|3"`

118. #### def mkString(start: String, sep: String, end: String): String

     Displays all elements of this array stack in a string using start, end, and separator strings.

     Displays all elements of this array stack in a string using start, end, and separator strings.

     start

       the starting string.

     sep

       the separator string.

     end

       the ending string.

     returns

       a string representation of this array stack. The resulting string begins with the string `start` and ends with the string `end`. Inside, the string representations (w.r.t. the method `toString`) of all elements of this array stack are separated by the string `sep`.

     Definition Classes
       TraversableOnce → GenTraversableOnce
     Example:

     1. `List(1, 2, 3).mkString("(", "; ", ")") = "(1; 2; 3)"`

119. #### final def ne(arg0: AnyRef): Boolean

     Equivalent to `!(this eq that)`.

     Equivalent to `!(this eq that)`.

     returns

       `true` if the argument is not a reference to the receiver object; `false` otherwise.

     Definition Classes
       AnyRef

120. #### def newBuilder: Builder[T, ArrayStack[T]]

     The builder that builds instances of type `ArrayStack`[A]

     The builder that builds instances of type `ArrayStack`[A]

     Attributes
       protected[this]
     Definition Classes
       GenericTraversableTemplate → HasNewBuilder

121. #### def nonEmpty: Boolean

     Tests whether the array stack is not empty.

     Tests whether the array stack is not empty.

     returns

       `true` if the array stack contains at least one element, `false` otherwise.

     Definition Classes
       TraversableOnce → GenTraversableOnce

122. #### final def notify(): Unit

     Wakes up a single thread that is waiting on the receiver object's monitor.

     Wakes up a single thread that is waiting on the receiver object's monitor.

     Definition Classes
       AnyRef
     Note

       not specified by SLS as a member of AnyRef

123. #### final def notifyAll(): Unit

     Wakes up all threads that are waiting on the receiver object's monitor.

     Wakes up all threads that are waiting on the receiver object's monitor.

     Definition Classes
       AnyRef
     Note

       not specified by SLS as a member of AnyRef

124. #### def orElse[A1 <: Int, B1 >: T](that: PartialFunction[A1, B1]): PartialFunction[A1, B1]

     Composes this partial function with a fallback partial function which gets applied where this partial function is not defined.

     Composes this partial function with a fallback partial function which gets applied where this partial function is not defined.

     A1

       the argument type of the fallback function

     B1

       the result type of the fallback function

     that

       the fallback function

     returns

       a partial function which has as domain the union of the domains of this partial function and `that`. The resulting partial function takes `x` to `this(x)` where `this` is defined, and to `that(x)` where it is not.

     Definition Classes
       PartialFunction

125. #### def padTo(len: Int, elem: A): ArrayStack[A]

     [use case] A copy of this array stack with an element value appended until a given target length is reached.

     [use case]

     A copy of this array stack with an element value appended until a given target length is reached.

     len

       the target length

     elem

       the padding value

     returns

       a new array stack consisting of all elements of this array stack followed by the minimal number of occurrences of `elem` so that the resulting array stack has a length of at least `len`.

     Definition Classes
       SeqLike → GenSeqLike
     Full Signature

     #### def padTo[B >: T, That](len: Int, elem: B)(implicit bf: CanBuildFrom[ArrayStack[T], B, That]): That

126. #### def par: ParSeq[T]

     Returns a parallel implementation of this collection.

     Returns a parallel implementation of this collection.

     For most collection types, this method creates a new parallel collection by copying all the elements. For these collection, `par` takes linear time. Mutable collections in this category do not produce a mutable parallel collection that has the same underlying dataset, so changes in one collection will not be reflected in the other one.

     Specific collections (e.g. `ParArray` or `mutable.ParHashMap`) override this default behaviour by creating a parallel collection which shares the same underlying dataset. For these collections, `par` takes constant or sublinear time.

     All parallel collections return a reference to themselves.

     returns

       a parallel implementation of this collection

     Definition Classes
       Parallelizable

127. #### def parCombiner: Combiner[T, ParSeq[T]]

     The default `par` implementation uses the combiner provided by this method to create a new parallel collection.

     The default `par` implementation uses the combiner provided by this method to create a new parallel collection.

     returns

       a combiner for the parallel collection of type `ParRepr`

     Attributes
       protected[this]
     Definition Classes
       SeqLike → SeqLike → TraversableLike → Parallelizable

128. #### def partition(p: (T) ⇒ Boolean): (ArrayStack[T], ArrayStack[T])

     Partitions this array stack in two array stacks according to a predicate.

     Partitions this array stack in two array stacks according to a predicate.

     p

       the predicate on which to partition.

     returns

       a pair of array stacks: the first array stack consists of all elements that satisfy the predicate `p` and the second array stack consists of all elements that don't. The relative order of the elements in the resulting array stacks is the same as in the original array stack.

     Definition Classes
       TraversableLike → GenTraversableLike

129. #### def patch(from: Int, that: GenSeq[A], replaced: Int): ArrayStack[A]

     [use case] Produces a new array stack where a slice of elements in this array stack is replaced by another sequence.

     [use case]

     Produces a new array stack where a slice of elements in this array stack is replaced by another sequence.

     from

       the index of the first replaced element

     replaced

       the number of elements to drop in the original array stack

     returns

       a new array stack consisting of all elements of this array stack except that `replaced` elements starting from `from` are replaced by `patch`.

     Definition Classes
       SeqLike → GenSeqLike
     Full Signature

     #### def patch[B >: T, That](from: Int, patch: GenSeq[B], replaced: Int)(implicit bf: CanBuildFrom[ArrayStack[T], B, That]): That

130. #### def permutations: Iterator[ArrayStack[T]]

     Iterates over distinct permutations.

     Iterates over distinct permutations.

     returns

       An Iterator which traverses the distinct permutations of this array stack.

     Definition Classes
       SeqLike
     Example:

     1. `"abb".permutations = Iterator(abb, bab, bba)`

131. #### def pop(): T

     Pop the top element off the stack.

     Pop the top element off the stack.

     returns

       the element on top of the stack

132. #### def prefixLength(p: (T) ⇒ Boolean): Int

     Returns the length of the longest prefix whose elements all satisfy some predicate.

     Returns the length of the longest prefix whose elements all satisfy some predicate.

     p

       the predicate used to test elements.

     returns

       the length of the longest prefix of this array stack such that every element of the segment satisfies the predicate `p`.

     Definition Classes
       GenSeqLike

133. #### def preserving[T](action: ⇒ T): T

     Evaluates the expression, preserving the contents of the stack so that any changes the evaluation makes to the stack contents will be undone after it completes.

     Evaluates the expression, preserving the contents of the stack so that any changes the evaluation makes to the stack contents will be undone after it completes.

     action

       The action to run.

134. #### def product: A

     [use case] Multiplies up the elements of this collection.

     [use case]

     Multiplies up the elements of this collection.

     returns

       the product of all elements in this array stack of numbers of type `Int`. Instead of `Int`, any other type `T` with an implicit `Numeric[T]` implementation can be used as element type of the array stack and as result type of `product`. Examples of such types are: `Long`, `Float`, `Double`, `BigInt`.

     Definition Classes
       TraversableOnce → GenTraversableOnce
     Full Signature

     #### def product[B >: T](implicit num: Numeric[B]): B

135. #### def push(x: T): Unit

     Push an element onto the stack.

     Push an element onto the stack.

     x

       The element to push

136. #### def reduce[A1 >: T](op: (A1, A1) ⇒ A1): A1

     Reduces the elements of this array stack using the specified associative binary operator.

     Reduces the elements of this array stack using the specified associative binary operator.

     The order in which operations are performed on elements is unspecified and may be nondeterministic.

     A1

       A type parameter for the binary operator, a supertype of `A`.

     op

       A binary operator that must be associative.

     returns

       The result of applying reduce operator `op` between all the elements if the array stack is nonempty.

     Definition Classes
       TraversableOnce → GenTraversableOnce
     Exceptions thrown
       UnsupportedOperationException

       if this array stack is empty.

137. #### def reduceLeft[B >: T](op: (B, T) ⇒ B): B

     Applies a binary operator to all elements of this array stack, going left to right.

     Applies a binary operator to all elements of this array stack, going left to right.

     B

       the result type of the binary operator.

     op

       the binary operator.

     returns

       the result of inserting `op` between consecutive elements of this array stack, going left to right:

           op( op( ... op(x_1, x_2) ..., x_{n-1}), x_n)

       where `x1, ..., xn` are the elements of this array stack.

     Definition Classes
       TraversableOnce
     Exceptions thrown
       `UnsupportedOperationException`

       if this array stack is empty.

138. #### def reduceLeftOption[B >: T](op: (B, T) ⇒ B): Option[B]

     Optionally applies a binary operator to all elements of this array stack, going left to right.

     Optionally applies a binary operator to all elements of this array stack, going left to right.

     B

       the result type of the binary operator.

     op

       the binary operator.

     returns

       an option value containing the result of `reduceLeft(op)` is this array stack is nonempty, `None` otherwise.

     Definition Classes
       TraversableOnce → GenTraversableOnce

139. #### def reduceOption[A1 >: T](op: (A1, A1) ⇒ A1): Option[A1]

     Reduces the elements of this array stack, if any, using the specified associative binary operator.

     Reduces the elements of this array stack, if any, using the specified associative binary operator.

     The order in which operations are performed on elements is unspecified and may be nondeterministic.

     A1

       A type parameter for the binary operator, a supertype of `A`.

     op

       A binary operator that must be associative.

     returns

       An option value containing result of applying reduce operator `op` between all the elements if the collection is nonempty, and `None` otherwise.

     Definition Classes
       TraversableOnce → GenTraversableOnce

140. #### def reduceRight[B >: T](op: (T, B) ⇒ B): B

     Applies a binary operator to all elements of this array stack, going right to left.

     Applies a binary operator to all elements of this array stack, going right to left.

     B

       the result type of the binary operator.

     op

       the binary operator.

     returns

       the result of inserting `op` between consecutive elements of this array stack, going right to left:

           op(x_1, op(x_2, ..., op(x_{n-1}, x_n)...))

       where `x1, ..., xn` are the elements of this array stack.

     Definition Classes
       IterableLike → TraversableOnce → GenTraversableOnce
     Exceptions thrown
       `UnsupportedOperationException`

       if this array stack is empty.

141. #### def reduceRightOption[B >: T](op: (T, B) ⇒ B): Option[B]

     Optionally applies a binary operator to all elements of this array stack, going right to left.

     Optionally applies a binary operator to all elements of this array stack, going right to left.

     B

       the result type of the binary operator.

     op

       the binary operator.

     returns

       an option value containing the result of `reduceRight(op)` is this array stack is nonempty, `None` otherwise.

     Definition Classes
       TraversableOnce → GenTraversableOnce

142. #### def reduceWith(f: (T, T) ⇒ T): Unit

     Repeatedly combine the top elements of the stack until the stack contains only one element.

     Repeatedly combine the top elements of the stack until the stack contains only one element.

     f

       The function to apply repeatedly to topmost elements.

143. #### def repr: ArrayStack[T]

     The collection of type array stack underlying this `TraversableLike` object.

     The collection of type array stack underlying this `TraversableLike` object. By default this is implemented as the `TraversableLike` object itself, but this can be overridden.

     Definition Classes
       TraversableLike → GenTraversableLike

144. #### def result(): ArrayStack[T]

     Produces a collection from the added elements.

     Produces a collection from the added elements. The builder's contents are undefined after this operation.

     returns

       a collection containing the elements added to this builder.

     Definition Classes
       ArrayStack → Builder

145. #### def reverse: ArrayStack[T]

     Returns new array stack wih elements in reversed order.

     Returns new array stack wih elements in reversed order.

     returns

       A new array stack with all elements of this array stack in reversed order.

     Definition Classes
       SeqLike → GenSeqLike

146. #### def reverseIterator: Iterator[T]

     An iterator yielding elements in reversed order.

     An iterator yielding elements in reversed order.

     Note: `xs.reverseIterator` is the same as `xs.reverse.iterator` but might be more efficient.

     returns

       an iterator yielding the elements of this array stack in reversed order

     Definition Classes
       SeqLike

147. #### def reverseMap[B](f: (A) ⇒ B): ArrayStack[B]

     [use case] Builds a new collection by applying a function to all elements of this array stack and collecting the results in reversed order.

     [use case]

     Builds a new collection by applying a function to all elements of this array stack and collecting the results in reversed order.

     Note: `xs.reverseMap(f)` is the same as `xs.reverse.map(f)` but might be more efficient.

     B

       the element type of the returned collection.

     f

       the function to apply to each element.

     returns

       a new array stack resulting from applying the given function `f` to each element of this array stack and collecting the results in reversed order.

     Definition Classes
       SeqLike → GenSeqLike
     Full Signature

     #### def reverseMap[B, That](f: (T) ⇒ B)(implicit bf: CanBuildFrom[ArrayStack[T], B, That]): That

148. #### def reversed: List[T]

     Attributes
       protected[this]
     Definition Classes
       TraversableOnce

149. #### def runWith[U](action: (T) ⇒ U): (Int) ⇒ Boolean

     Composes this partial function with an action function which gets applied to results of this partial function.

     Composes this partial function with an action function which gets applied to results of this partial function. The action function is invoked only for its side effects; its result is ignored.

     Note that expression `pf.runWith(action)(x)` is equivalent to

         if(pf isDefinedAt x) { action(pf(x)); true } else false

     except that `runWith` is implemented via `applyOrElse` and thus potentially more efficient. Using `runWith` avoids double evaluation of pattern matchers and guards for partial function literals.

     action

       the action function

     returns

       a function which maps arguments `x` to `isDefinedAt(x)`. The resulting function runs `action(this(x))` where `this` is defined.

     Definition Classes
       PartialFunction
     Since

       2.10

     See also

       `applyOrElse`.

150. #### def sameElements(that: GenIterable[A]): Boolean

     [use case] Checks if the other iterable collection contains the same elements in the same order as this array stack.

     [use case]

     Checks if the other iterable collection contains the same elements in the same order as this array stack.

     that

       the collection to compare with.

     returns

       `true`, if both collections contain the same elements in the same order, `false` otherwise.

     Definition Classes
       IterableLike → GenIterableLike
     Full Signature

     #### def sameElements[B >: T](that: GenIterable[B]): Boolean

151. #### def scan[B >: T, That](z: B)(op: (B, B) ⇒ B)(implicit cbf: CanBuildFrom[ArrayStack[T], B, That]): That

     Computes a prefix scan of the elements of the collection.

     Computes a prefix scan of the elements of the collection.

     Note: The neutral element `z` may be applied more than once.

     B

       element type of the resulting collection

     That

       type of the resulting collection

     z

       neutral element for the operator `op`

     op

       the associative operator for the scan

     cbf

       combiner factory which provides a combiner

     returns

       a new array stack containing the prefix scan of the elements in this array stack

     Definition Classes
       TraversableLike → GenTraversableLike

152. #### def scanLeft[B, That](z: B)(op: (B, T) ⇒ B)(implicit bf: CanBuildFrom[ArrayStack[T], B, That]): That

     Produces a collection containing cumulative results of applying the operator going left to right.

     Produces a collection containing cumulative results of applying the operator going left to right.

     B

       the type of the elements in the resulting collection

     That

       the actual type of the resulting collection

     z

       the initial value

     op

       the binary operator applied to the intermediate result and the element

     bf

       an implicit value of class `CanBuildFrom` which determines the result class `That` from the current representation type `Repr` and the new element type `B`.

     returns

       collection with intermediate results

     Definition Classes
       TraversableLike → GenTraversableLike

153. #### def scanRight[B, That](z: B)(op: (T, B) ⇒ B)(implicit bf: CanBuildFrom[ArrayStack[T], B, That]): That

     Produces a collection containing cumulative results of applying the operator going right to left.

     Produces a collection containing cumulative results of applying the operator going right to left. The head of the collection is the last cumulative result.

     Example:

         List(1, 2, 3, 4).scanRight(0)(_ + _) == List(10, 9, 7, 4, 0)

     B

       the type of the elements in the resulting collection

     That

       the actual type of the resulting collection

     z

       the initial value

     op

       the binary operator applied to the intermediate result and the element

     bf

       an implicit value of class `CanBuildFrom` which determines the result class `That` from the current representation type `Repr` and the new element type `B`.

     returns

       collection with intermediate results

     Definition Classes
       TraversableLike → GenTraversableLike
     Annotations
       @migration
     Migration

       (Changed in version 2.9.0) The behavior of `scanRight` has changed. The previous behavior can be reproduced with scanRight.reverse.

154. #### def segmentLength(p: (T) ⇒ Boolean, from: Int): Int

     Computes length of longest segment whose elements all satisfy some predicate.

     Computes length of longest segment whose elements all satisfy some predicate.

     p

       the predicate used to test elements.

     from

       the index where the search starts.

     returns

       the length of the longest segment of this array stack starting from index `from` such that every element of the segment satisfies the predicate `p`.

     Definition Classes
       SeqLike → GenSeqLike

155. #### def seq: Seq[T]

     A version of this collection with all of the operations implemented sequentially (i.

     A version of this collection with all of the operations implemented sequentially (i.e. in a single-threaded manner).

     This method returns a reference to this collection. In parallel collections, it is redefined to return a sequential implementation of this collection. In both cases, it has O(1) complexity.

     returns

       a sequential view of the collection.

     Definition Classes
       Seq → Seq → GenSeq → GenSeqLike → Iterable → Iterable → GenIterable → Traversable → Traversable → GenTraversable → Parallelizable → TraversableOnce → GenTraversableOnce

156. #### def size: Int

     The size of this array stack, equivalent to `length`.

     The size of this array stack, equivalent to `length`.

     returns

       the number of elements in this array stack.

     Definition Classes
       ArrayStack → SeqLike → GenTraversableLike → TraversableOnce → GenTraversableOnce

157. #### def sizeHint(coll: TraversableLike[_, _], delta: Int): Unit

     Gives a hint that one expects the `result` of this builder to have the same size as the given collection, plus some delta.

     Gives a hint that one expects the `result` of this builder to have the same size as the given collection, plus some delta. This will provide a hint only if the collection is known to have a cheap `size` method. Currently this is assumed to be the case if and only if the collection is of type `IndexedSeqLike`. Some builder classes will optimize their representation based on the hint. However, builder implementations are still required to work correctly even if the hint is wrong, i.e. a different number of elements is added.

     coll

       the collection which serves as a hint for the result's size.

     delta

       a correction to add to the `coll.size` to produce the size hint.

     Definition Classes
       Builder

158. #### def sizeHint(coll: TraversableLike[_, _]): Unit

     Gives a hint that one expects the `result` of this builder to have the same size as the given collection, plus some delta.

     Gives a hint that one expects the `result` of this builder to have the same size as the given collection, plus some delta. This will provide a hint only if the collection is known to have a cheap `size` method. Currently this is assumed to be the case if and only if the collection is of type `IndexedSeqLike`. Some builder classes will optimize their representation based on the hint. However, builder implementations are still required to work correctly even if the hint is wrong, i.e. a different number of elements is added.

     coll

       the collection which serves as a hint for the result's size.

     Definition Classes
       Builder

159. #### def sizeHint(size: Int): Unit

     Gives a hint how many elements are expected to be added when the next `result` is called.

     Gives a hint how many elements are expected to be added when the next `result` is called. Some builder classes will optimize their representation based on the hint. However, builder implementations are still required to work correctly even if the hint is wrong, i.e. a different number of elements is added.

     size

       the hint how many elements will be added.

     Definition Classes
       Builder

160. #### def sizeHintBounded(size: Int, boundingColl: TraversableLike[_, _]): Unit

     Gives a hint how many elements are expected to be added when the next `result` is called, together with an upper bound given by the size of some other collection.

     Gives a hint how many elements are expected to be added when the next `result` is called, together with an upper bound given by the size of some other collection. Some builder classes will optimize their representation based on the hint. However, builder implementations are still required to work correctly even if the hint is wrong, i.e. a different number of elements is added.

     size

       the hint how many elements will be added.

     boundingColl

       the bounding collection. If it is an IndexedSeqLike, then sizes larger than collection's size are reduced.

     Definition Classes
       Builder

161. #### def slice(from: Int, until: Int): ArrayStack[T]

     Selects an interval of elements.

     Selects an interval of elements. The returned collection is made up of all elements `x` which satisfy the invariant:

         from <= indexOf(x) < until

     returns

       a array stack containing the elements greater than or equal to index `from` extending up to (but not including) index `until` of this array stack.

     Definition Classes
       IterableLike → TraversableLike → GenTraversableLike

162. #### def sliding(size: Int, step: Int): Iterator[ArrayStack[T]]

     Groups elements in fixed size blocks by passing a "sliding window" over them (as opposed to partitioning them, as is done in grouped.

     Groups elements in fixed size blocks by passing a "sliding window" over them (as opposed to partitioning them, as is done in grouped.)

     size

       the number of elements per group

     step

       the distance between the first elements of successive groups (defaults to 1)

     returns

       An iterator producing array stacks of size `size`, except the last and the only element will be truncated if there are fewer elements than size.

     Definition Classes
       IterableLike
     See also

       scala.collection.Iterator, method `sliding`

163. #### def sliding(size: Int): Iterator[ArrayStack[T]]

     Groups elements in fixed size blocks by passing a "sliding window" over them (as opposed to partitioning them, as is done in grouped.

     Groups elements in fixed size blocks by passing a "sliding window" over them (as opposed to partitioning them, as is done in grouped.)

     size

       the number of elements per group

     returns

       An iterator producing array stacks of size `size`, except the last and the only element will be truncated if there are fewer elements than size.

     Definition Classes
       IterableLike
     See also

       scala.collection.Iterator, method `sliding`

164. #### def sortBy[B](f: (T) ⇒ B)(implicit ord: math.Ordering[B]): ArrayStack[T]

     Sorts this `ArrayStack` according to the Ordering which results from transforming an implicitly given Ordering with a transformation function.

     Sorts this `ArrayStack` according to the Ordering which results from transforming an implicitly given Ordering with a transformation function.

     B

       the target type of the transformation `f`, and the type where the ordering `ord` is defined.

     f

       the transformation function mapping elements to some other domain `B`.

     ord

       the ordering assumed on domain `B`.

     returns

       a array stack consisting of the elements of this array stack sorted according to the ordering where `x < y` if `ord.lt(f(x), f(y))`.

     Definition Classes
       SeqLike
     Example:

     1.     val words = "The quick brown fox jumped over the lazy dog".split(' ')
            // this works because scala.Ordering will implicitly provide an Ordering[Tuple2[Int, Char]]
            words.sortBy(x => (x.length, x.head))
            res0: Array[String] = Array(The, dog, fox, the, lazy, over, brown, quick, jumped)

     See also

       scala.math.Ordering

165. #### def sortWith(lt: (T, T) ⇒ Boolean): ArrayStack[T]

     Sorts this array stack according to a comparison function.

     Sorts this array stack according to a comparison function.

     The sort is stable. That is, elements that are equal (as determined by `lt`) appear in the same order in the sorted sequence as in the original.

     lt

       the comparison function which tests whether its first argument precedes its second argument in the desired ordering.

     returns

       a array stack consisting of the elements of this array stack sorted according to the comparison function `lt`.

     Definition Classes
       SeqLike
     Example:

     1.     List("Steve", "Tom", "John", "Bob").sortWith(_.compareTo(_) < 0) =
            List("Bob", "John", "Steve", "Tom")

166. #### def sorted[B >: T](implicit ord: math.Ordering[B]): ArrayStack[T]

     Sorts this array stack according to an Ordering.

     Sorts this array stack according to an Ordering.

     The sort is stable. That is, elements that are equal (as determined by `lt`) appear in the same order in the sorted sequence as in the original.

     ord

       the ordering to be used to compare elements.

     returns

       a array stack consisting of the elements of this array stack sorted according to the ordering `ord`.

     Definition Classes
       SeqLike
     See also

       scala.math.Ordering

167. #### def span(p: (T) ⇒ Boolean): (ArrayStack[T], ArrayStack[T])

     Splits this array stack into a prefix/suffix pair according to a predicate.

     Splits this array stack into a prefix/suffix pair according to a predicate.

     Note: `c span p` is equivalent to (but possibly more efficient than) `(c takeWhile p, c dropWhile p)`, provided the evaluation of the predicate `p` does not cause any side-effects.

     returns

       a pair consisting of the longest prefix of this array stack whose elements all satisfy `p`, and the rest of this array stack.

     Definition Classes
       TraversableLike → GenTraversableLike

168. #### def splitAt(n: Int): (ArrayStack[T], ArrayStack[T])

     Splits this array stack into two at a given position.

     Splits this array stack into two at a given position. Note: `c splitAt n` is equivalent to (but possibly more efficient than) `(c take n, c drop n)`.

     n

       the position at which to split.

     returns

       a pair of array stacks consisting of the first `n` elements of this array stack, and the other elements.

     Definition Classes
       TraversableLike → GenTraversableLike

169. #### def startsWith[B](that: GenSeq[B], offset: Int): Boolean

     Tests whether this array stack contains the given sequence at a given index.

     Tests whether this array stack contains the given sequence at a given index.

     Note: If the both the receiver object `this` and the argument `that` are infinite sequences this method may not terminate.

     that

       the sequence to test

     offset

       the index where the sequence is searched.

     returns

       `true` if the sequence `that` is contained in this array stack at index `offset`, otherwise `false`.

     Definition Classes
       SeqLike → GenSeqLike

170. #### def startsWith[B](that: GenSeq[B]): Boolean

     Tests whether this array stack starts with the given sequence.

     Tests whether this array stack starts with the given sequence.

     that

       the sequence to test

     returns

       `true` if this collection has `that` as a prefix, `false` otherwise.

     Definition Classes
       GenSeqLike

171. #### def stringPrefix: String

     Defines the prefix of this object's `toString` representation.

     Defines the prefix of this object's `toString` representation.

     returns

       a string representation which starts the result of `toString` applied to this array stack. By default the string prefix is the simple name of the collection class array stack.

     Definition Classes
       TraversableLike → GenTraversableLike

172. #### def sum: A

     [use case] Sums up the elements of this collection.

     [use case]

     Sums up the elements of this collection.

     returns

       the sum of all elements in this array stack of numbers of type `Int`. Instead of `Int`, any other type `T` with an implicit `Numeric[T]` implementation can be used as element type of the array stack and as result type of `sum`. Examples of such types are: `Long`, `Float`, `Double`, `BigInt`.

     Definition Classes
       TraversableOnce → GenTraversableOnce
     Full Signature

     #### def sum[B >: T](implicit num: Numeric[B]): B

173. #### final def synchronized[T0](arg0: ⇒ T0): T0

     Definition Classes
       AnyRef

174. #### def tail: ArrayStack[T]

     Selects all elements except the first.

     Selects all elements except the first.

     returns

       a array stack consisting of all elements of this array stack except the first one.

     Definition Classes
       TraversableLike → GenTraversableLike
     Exceptions thrown
       `UnsupportedOperationException`

       if the array stack is empty.

175. #### def tails: Iterator[ArrayStack[T]]

     Iterates over the tails of this array stack.

     Iterates over the tails of this array stack. The first value will be this array stack and the final one will be an empty array stack, with the intervening values the results of successive applications of `tail`.

     returns

       an iterator over all the tails of this array stack

     Definition Classes
       TraversableLike
     Example:

     1. `List(1,2,3).tails = Iterator(List(1,2,3), List(2,3), List(3), Nil)`

176. #### def take(n: Int): ArrayStack[T]

     Selects first n elements.

     Selects first n elements.

     n

       the number of elements to take from this array stack.

     returns

       a array stack consisting only of the first `n` elements of this array stack, or else the whole array stack, if it has less than `n` elements.

     Definition Classes
       IterableLike → TraversableLike → GenTraversableLike

177. #### def takeRight(n: Int): ArrayStack[T]

     Selects last n elements.

     Selects last n elements.

     n

       the number of elements to take

     returns

       a array stack consisting only of the last `n` elements of this array stack, or else the whole array stack, if it has less than `n` elements.

     Definition Classes
       IterableLike

178. #### def takeWhile(p: (T) ⇒ Boolean): ArrayStack[T]

     Takes longest prefix of elements that satisfy a predicate.

     Takes longest prefix of elements that satisfy a predicate.

     returns

       the longest prefix of this array stack whose elements all satisfy the predicate `p`.

     Definition Classes
       IterableLike → TraversableLike → GenTraversableLike

179. #### def thisCollection: collection.Seq[T]

     The underlying collection seen as an instance of ``ArrayStack``.

     The underlying collection seen as an instance of ``ArrayStack``. By default this is implemented as the current collection object itself, but this can be overridden.

     Attributes
       protected[this]
     Definition Classes
       SeqLike → IterableLike → TraversableLike

180. #### def to[Col[_]]: Col[A]

     [use case] Converts this array stack into another by copying all elements.

     [use case]

     Converts this array stack into another by copying all elements.

     Col

       The collection type to build.

     returns

       a new collection containing all elements of this array stack.

     Definition Classes
       TraversableLike → TraversableOnce → GenTraversableOnce
     Full Signature

     #### def to[Col[_]](implicit cbf: CanBuildFrom[Nothing, T, Col[T]]): Col[T]

181. #### def toArray: Array[A]

     [use case] Converts this array stack to an array.

     [use case]

     Converts this array stack to an array.

     returns

       an array containing all elements of this array stack. An `ClassTag` must be available for the element type of this array stack.

     Definition Classes
       TraversableOnce → GenTraversableOnce
     Full Signature

     #### def toArray[B >: T](implicit arg0: ClassTag[B]): Array[B]

182. #### def toBuffer[B >: T]: Buffer[B]

     Converts this array stack to a mutable buffer.

     Converts this array stack to a mutable buffer.

     returns

       a buffer containing all elements of this array stack.

     Definition Classes
       TraversableOnce → GenTraversableOnce

183. #### def toCollection(repr: ArrayStack[T]): collection.Seq[T]

     A conversion from collections of type `Repr` to ``ArrayStack`` objects.

     A conversion from collections of type `Repr` to ``ArrayStack`` objects. By default this is implemented as just a cast, but this can be overridden.

     Attributes
       protected[this]
     Definition Classes
       SeqLike → IterableLike → TraversableLike

184. #### def toIndexedSeq: immutable.IndexedSeq[T]

     Converts this array stack to an indexed sequence.

     Converts this array stack to an indexed sequence.

     returns

       an indexed sequence containing all elements of this array stack.

     Definition Classes
       TraversableOnce → GenTraversableOnce

185. #### def toIterable: collection.Iterable[T]

     Converts this array stack to an iterable collection.

     Converts this array stack to an iterable collection. Note that the choice of target `Iterable` is lazy in this default implementation as this `TraversableOnce` may be lazy and unevaluated (i.e. it may be an iterator which is only traversable once).

     returns

       an `Iterable` containing all elements of this array stack.

     Definition Classes
       IterableLike → TraversableOnce → GenTraversableOnce

186. #### def toIterator: Iterator[T]

     Returns an Iterator over the elements in this array stack.

     Returns an Iterator over the elements in this array stack. Will return the same Iterator if this instance is already an Iterator.

     returns

       an Iterator containing all elements of this array stack.

     Definition Classes
       IterableLike → TraversableLike → GenTraversableOnce

187. #### def toList: List[T]

     Converts this array stack to a list.

     Converts this array stack to a list.

     returns

       a list containing all elements of this array stack.

     Definition Classes
       TraversableOnce → GenTraversableOnce

188. #### def toMap[T, U]: collection.Map[T, U]

     [use case] Converts this array stack to a map.

     [use case]

     Converts this array stack to a map. This method is unavailable unless the elements are members of Tuple2, each ((T, U)) becoming a key-value pair in the map. Duplicate keys will be overwritten by later keys: if this is an unordered collection, which key is in the resulting map is undefined.

     returns

       a map of type `immutable.Map[T, U]` containing all key/value pairs of type `(T, U)` of this array stack.

     Definition Classes
       TraversableOnce → GenTraversableOnce
     Full Signature

     #### def toMap[T, U](implicit ev: <:<[T, (T, U)]): immutable.Map[T, U]

189. #### def toParArray: ParArray[T]

     Implicit information
       This member is added by an implicit conversion from ArrayStack[T] to TraversableOps[T] performed by method traversable2ops in scala.collection.parallel.
     Definition Classes
       TraversableOps

190. #### def toSeq: collection.Seq[T]

     Converts this array stack to a sequence.

     Converts this array stack to a sequence.

     Overridden for efficiency.

     returns

       a sequence containing all elements of this array stack.

     Definition Classes
       SeqLike → GenSeqLike → TraversableOnce → GenTraversableOnce

191. #### def toSet[B >: T]: immutable.Set[B]

     Converts this array stack to a set.

     Converts this array stack to a set.

     returns

       a set containing all elements of this array stack.

     Definition Classes
       TraversableOnce → GenTraversableOnce

192. #### def toStream: immutable.Stream[T]

     Converts this array stack to a stream.

     Converts this array stack to a stream.

     returns

       a stream containing all elements of this array stack.

     Definition Classes
       IterableLike → TraversableLike → GenTraversableOnce

193. #### def toString(): String

     Converts this array stack to a string.

     Converts this array stack to a string.

     returns

       a string representation of this collection. By default this string consists of the `stringPrefix` of this array stack, followed by all elements separated by commas and enclosed in parentheses.

     Definition Classes
       SeqLike → TraversableLike → Any

194. #### def toTraversable: collection.Traversable[T]

     Converts this array stack to an unspecified Traversable.

     Converts this array stack to an unspecified Traversable. Will return the same collection if this instance is already Traversable.

     returns

       a Traversable containing all elements of this array stack.

     Definition Classes
       TraversableLike → TraversableOnce → GenTraversableOnce

195. #### def toVector: Vector[T]

     Converts this array stack to a Vector.

     Converts this array stack to a Vector.

     returns

       a vector containing all elements of this array stack.

     Definition Classes
       TraversableOnce → GenTraversableOnce

196. #### def top: T

     View the top element of the stack.

     View the top element of the stack.

     Does not remove the element on the top. If the stack is empty, an exception is thrown.

     returns

       the element on top of the stack.

197. #### def transform(f: (T) ⇒ T): ArrayStack.this.type

     Applies a transformation function to all values contained in this sequence.

     Applies a transformation function to all values contained in this sequence. The transformation function produces new values from existing elements.

     f

       the transformation to apply

     returns

       the sequence itself.

     Definition Classes
       SeqLike

198. #### def transpose[B](implicit asTraversable: (T) ⇒ GenTraversableOnce[B]): ArrayStack[ArrayStack[B]]

     Transposes this array stack of traversable collections into a array stack of array stacks.

     Transposes this array stack of traversable collections into a array stack of array stacks.

     B

       the type of the elements of each traversable collection.

     asTraversable

       an implicit conversion which asserts that the element type of this array stack is a `Traversable`.

     returns

       a two-dimensional array stack of array stacks which has as nth row the nth column of this array stack.

     Definition Classes
       GenericTraversableTemplate
     Annotations
       @migration
     Migration

       (Changed in version 2.9.0) `transpose` throws an `IllegalArgumentException` if collections are not uniformly sized.

     Exceptions thrown
       `IllegalArgumentException`

       if all collections in this array stack are not of the same size.

199. #### def union(that: collection.Seq[T]): ArrayStack[T]

     [use case] Produces a new sequence which contains all elements of this array stack and also all elements of a given sequence.

     [use case]

     Produces a new sequence which contains all elements of this array stack and also all elements of a given sequence. `xs union ys` is equivalent to `xs ++ ys`.

     Another way to express this is that `xs union ys` computes the order-presevring multi-set union of `xs` and `ys`. `union` is hence a counter-part of `diff` and `intersect` which also work on multi-sets.

     that

       the sequence to add.

     returns

       a new array stack which contains all elements of this array stack followed by all elements of `that`.

     Definition Classes
       SeqLike → GenSeqLike
     Full Signature

     #### def union[B >: T, That](that: GenSeq[B])(implicit bf: CanBuildFrom[ArrayStack[T], B, That]): That

200. #### def unzip[A1, A2](implicit asPair: (T) ⇒ (A1, A2)): (ArrayStack[A1], ArrayStack[A2])

     Converts this array stack of pairs into two collections of the first and second half of each pair.

     Converts this array stack of pairs into two collections of the first and second half of each pair.

     A1

       the type of the first half of the element pairs

     A2

       the type of the second half of the element pairs

     asPair

       an implicit conversion which asserts that the element type of this array stack is a pair.

     returns

       a pair array stacks, containing the first, respectively second half of each element pair of this array stack.

     Definition Classes
       GenericTraversableTemplate

201. #### def unzip3[A1, A2, A3](implicit asTriple: (T) ⇒ (A1, A2, A3)): (ArrayStack[A1], ArrayStack[A2], ArrayStack[A3])

     Converts this array stack of triples into three collections of the first, second, and third element of each triple.

     Converts this array stack of triples into three collections of the first, second, and third element of each triple.

     A1

       the type of the first member of the element triples

     A2

       the type of the second member of the element triples

     A3

       the type of the third member of the element triples

     asTriple

       an implicit conversion which asserts that the element type of this array stack is a triple.

     returns

       a triple array stacks, containing the first, second, respectively third member of each element triple of this array stack.

     Definition Classes
       GenericTraversableTemplate

202. #### def update(n: Int, newelem: T): Unit

     Replace element at index `n` with the new element `newelem`.

     Replace element at index `n` with the new element `newelem`.

     This is a constant time operation.

     n

       the index of the element to replace.

     newelem

       the new element.

     Definition Classes
       ArrayStack → SeqLike
     Exceptions thrown
       IndexOutOfBoundsException

       if the index is not valid

203. #### def updated(index: Int, elem: A): ArrayStack[A]

     [use case] A copy of this array stack with one single replaced element.

     [use case]

     A copy of this array stack with one single replaced element.

     index

       the position of the replacement

     elem

       the replacing element

     returns

       a copy of this array stack with the element at position `index` replaced by `elem`.

     Definition Classes
       SeqLike → GenSeqLike
     Full Signature

     #### def updated[B >: T, That](index: Int, elem: B)(implicit bf: CanBuildFrom[ArrayStack[T], B, That]): That

204. #### def view(from: Int, until: Int): SeqView[T, ArrayStack[T]]

     Creates a non-strict view of a slice of this array stack.

     Creates a non-strict view of a slice of this array stack.

     Note: the difference between `view` and `slice` is that `view` produces a view of the current array stack, whereas `slice` produces a new array stack.

     Note: `view(from, to)` is equivalent to `view.slice(from, to)`

     from

       the index of the first element of the view

     until

       the index of the element following the view

     returns

       a non-strict view of a slice of this array stack, starting at index `from` and extending up to (but not including) index `until`.

     Definition Classes
       SeqLike → IterableLike → TraversableLike

205. #### def view: SeqView[T, ArrayStack[T]]

     Creates a non-strict view of this array stack.

     Creates a non-strict view of this array stack.

     returns

       a non-strict view of this array stack.

     Definition Classes
       SeqLike → IterableLike → TraversableLike

206. #### final def wait(): Unit

     Definition Classes
       AnyRef
     Annotations
       @throws( ... )

207. #### final def wait(arg0: Long, arg1: Int): Unit

     Definition Classes
       AnyRef
     Annotations
       @throws( ... )

208. #### final def wait(arg0: Long): Unit

     Definition Classes
       AnyRef
     Annotations
       @throws( ... )

209. #### def withFilter(p: (T) ⇒ Boolean): FilterMonadic[T, ArrayStack[T]]

     Creates a non-strict filter of this array stack.

     Creates a non-strict filter of this array stack.

     Note: the difference between `c filter p` and `c withFilter p` is that the former creates a new collection, whereas the latter only restricts the domain of subsequent `map`, `flatMap`, `foreach`, and `withFilter` operations.

     p

       the predicate used to test elements.

     returns

       an object of class `WithFilter`, which supports `map`, `flatMap`, `foreach`, and `withFilter` operations. All these operations apply to those elements of this array stack which satisfy the predicate `p`.

     Definition Classes
       TraversableLike → FilterMonadic

210. #### def zip[B](that: GenIterable[B]): ArrayStack[(A, B)]

     [use case] Returns a array stack formed from this array stack and another iterable collection by combining corresponding elements in pairs.

     [use case]

     Returns a array stack formed from this array stack and another iterable collection by combining corresponding elements in pairs. If one of the two collections is longer than the other, its remaining elements are ignored.

     B

       the type of the second half of the returned pairs

     that

       The iterable providing the second half of each result pair

     returns

       a new array stack containing pairs consisting of corresponding elements of this array stack and `that`. The length of the returned collection is the minimum of the lengths of this array stack and `that`.

     Definition Classes
       IterableLike → GenIterableLike
     Full Signature

     #### def zip[A1 >: T, B, That](that: GenIterable[B])(implicit bf: CanBuildFrom[ArrayStack[T], (A1, B), That]): That

211. #### def zipAll[B](that: collection.Iterable[B], thisElem: A, thatElem: B): ArrayStack[(A, B)]

     [use case] Returns a array stack formed from this array stack and another iterable collection by combining corresponding elements in pairs.

     [use case]

     Returns a array stack formed from this array stack and another iterable collection by combining corresponding elements in pairs. If one of the two collections is shorter than the other, placeholder elements are used to extend the shorter collection to the length of the longer.

     B

       the type of the second half of the returned pairs

     that

       The iterable providing the second half of each result pair

     thisElem

       the element to be used to fill up the result if this array stack is shorter than `that`.

     thatElem

       the element to be used to fill up the result if `that` is shorter than this array stack.

     returns

       a new array stack containing pairs consisting of corresponding elements of this array stack and `that`. The length of the returned collection is the maximum of the lengths of this array stack and `that`. If this array stack is shorter than `that`, `thisElem` values are used to pad the result. If `that` is shorter than this array stack, `thatElem` values are used to pad the result.

     Definition Classes
       IterableLike → GenIterableLike
     Full Signature

     #### def zipAll[B, A1 >: T, That](that: GenIterable[B], thisElem: A1, thatElem: B)(implicit bf: CanBuildFrom[ArrayStack[T], (A1, B), That]): That

212. #### def zipWithIndex: ArrayStack[(A, Int)]

     [use case] Zips this array stack with its indices.

     [use case]

     Zips this array stack with its indices.

     returns

       A new array stack containing pairs consisting of all elements of this array stack paired with their index. Indices start at `0`.

     Definition Classes
       IterableLike → GenIterableLike
     Full Signature

     #### def zipWithIndex[A1 >: T, That](implicit bf: CanBuildFrom[ArrayStack[T], (A1, Int), That]): That

     Example:

     1. `List("a", "b", "c").zipWithIndex = List(("a", 0), ("b", 1), ("c", 2))`

213. #### def →[B](y: B): (ArrayStack[T], B)

     Implicit information
       This member is added by an implicit conversion from ArrayStack[T] to ArrowAssoc[ArrayStack[T]] performed by method any2ArrowAssoc in scala.Predef.
     Definition Classes
       ArrowAssoc

### Shadowed Implicit Value Members

1. #### def filter(p: (T) ⇒ Boolean): TraversableOnce[T]

   Implicit information
     This member is added by an implicit conversion from ArrayStack[T] to MonadOps[T] performed by method MonadOps in scala.collection.TraversableOnce.
   Shadowing
     This implicitly inherited member is shadowed by one or more members in this class.
     To access this member you can use a type ascription:

         (arrayStack: MonadOps[T]).filter(p)

   Definition Classes
     MonadOps

2. #### def flatMap[B](f: (T) ⇒ GenTraversableOnce[B]): TraversableOnce[B]

   Implicit information
     This member is added by an implicit conversion from ArrayStack[T] to MonadOps[T] performed by method MonadOps in scala.collection.TraversableOnce.
   Shadowing
     This implicitly inherited member is shadowed by one or more members in this class.
     To access this member you can use a type ascription:

         (arrayStack: MonadOps[T]).flatMap(f)

   Definition Classes
     MonadOps

3. #### def map[B](f: (T) ⇒ B): TraversableOnce[B]

   Implicit information
     This member is added by an implicit conversion from ArrayStack[T] to MonadOps[T] performed by method MonadOps in scala.collection.TraversableOnce.
   Shadowing
     This implicitly inherited member is shadowed by one or more members in this class.
     To access this member you can use a type ascription:

         (arrayStack: MonadOps[T]).map(f)

   Definition Classes
     MonadOps

4. #### val self: Any

   Implicit information
     This member is added by an implicit conversion from ArrayStack[T] to StringAdd performed by method any2stringadd in scala.Predef.
   Shadowing
     This implicitly inherited member is ambiguous. One or more implicitly inherited members have similar signatures, so calling this member may produce an ambiguous implicit conversion compiler error.
     To access this member you can use a type ascription:

         (arrayStack: StringAdd).self

   Definition Classes
     StringAdd

5. #### val self: Any

   Implicit information
     This member is added by an implicit conversion from ArrayStack[T] to StringFormat performed by method any2stringfmt in scala.Predef.
   Shadowing
     This implicitly inherited member is ambiguous. One or more implicitly inherited members have similar signatures, so calling this member may produce an ambiguous implicit conversion compiler error.
     To access this member you can use a type ascription:

         (arrayStack: StringFormat).self

   Definition Classes
     StringFormat

6. #### def withFilter(p: (T) ⇒ Boolean): Iterator[T]

   Implicit information
     This member is added by an implicit conversion from ArrayStack[T] to MonadOps[T] performed by method MonadOps in scala.collection.TraversableOnce.
   Shadowing
     This implicitly inherited member is shadowed by one or more members in this class.
     To access this member you can use a type ascription:

         (arrayStack: MonadOps[T]).withFilter(p)

   Definition Classes
     MonadOps

### Deprecated Value Members

1. #### def /:\[A1 >: T](z: A1)(op: (A1, A1) ⇒ A1): A1

   A syntactic sugar for out of order folding.

   A syntactic sugar for out of order folding. See `fold`.

   Example:

       scala> val a = LinkedList(1,2,3,4)
       a: scala.collection.mutable.LinkedList[Int] = LinkedList(1, 2, 3, 4)

       scala> val b = (a /:\ 5)(_+_)
       b: Int = 15

   Definition Classes
     GenTraversableOnce
   Annotations
     @deprecated
   Deprecated

     (Since version 2.10.0) use fold instead

2. #### def x: ArrayStack[T]

   Implicit information
     This member is added by an implicit conversion from ArrayStack[T] to ArrowAssoc[ArrayStack[T]] performed by method any2ArrowAssoc in scala.Predef.
   Shadowing
     This implicitly inherited member is ambiguous. One or more implicitly inherited members have similar signatures, so calling this member may produce an ambiguous implicit conversion compiler error.
     To access this member you can use a type ascription:

         (arrayStack: ArrowAssoc[ArrayStack[T]]).x

   Definition Classes
     ArrowAssoc
   Annotations
     @deprecated
   Deprecated

     (Since version 2.10.0) Use `leftOfArrow`instead``

3. #### def x: ArrayStack[T]

   Implicit information
     This member is added by an implicit conversion from ArrayStack[T] to Ensuring[ArrayStack[T]] performed by method any2Ensuring in scala.Predef.
   Shadowing
     This implicitly inherited member is ambiguous. One or more implicitly inherited members have similar signatures, so calling this member may produce an ambiguous implicit conversion compiler error.
     To access this member you can use a type ascription:

         (arrayStack: Ensuring[ArrayStack[T]]).x

   Definition Classes
     Ensuring
   Annotations
     @deprecated
   Deprecated

     (Since version 2.10.0) Use `resultOfEnsuring`instead``

### Inherited from Serializable

### Inherited from java.io.Serializable

### Inherited from Builder[T, ArrayStack[T]]

### Inherited from Growable[T]

### Inherited from Clearable

### Inherited from AbstractSeq[T]

### Inherited from Seq[T]

### Inherited from SeqLike[T, ArrayStack[T]]

### Inherited from Cloneable[ArrayStack[T]]

### Inherited from scala.Cloneable

### Inherited from java.lang.Cloneable

### Inherited from Iterable[T]

### Inherited from Traversable[T]

### Inherited from Mutable

### Inherited from collection.AbstractSeq[T]

### Inherited from collection.Seq[T]

### Inherited from collection.SeqLike[T, ArrayStack[T]]

### Inherited from GenSeq[T]

### Inherited from GenSeqLike[T, ArrayStack[T]]

### Inherited from PartialFunction[Int, T]

### Inherited from (Int) ⇒ T

### Inherited from collection.AbstractIterable[T]

### Inherited from collection.Iterable[T]

### Inherited from IterableLike[T, ArrayStack[T]]

### Inherited from Equals

### Inherited from GenIterable[T]

### Inherited from GenIterableLike[T, ArrayStack[T]]

### Inherited from AbstractTraversable[T]

### Inherited from collection.Traversable[T]

### Inherited from GenTraversable[T]

### Inherited from GenericTraversableTemplate[T, ArrayStack]

### Inherited from TraversableLike[T, ArrayStack[T]]

### Inherited from GenTraversableLike[T, ArrayStack[T]]

### Inherited from Parallelizable[T, ParSeq[T]]

### Inherited from TraversableOnce[T]

### Inherited from GenTraversableOnce[T]

### Inherited from FilterMonadic[T, ArrayStack[T]]

### Inherited from HasNewBuilder[T, ArrayStack[T]]

### Inherited from AnyRef

### Inherited from Any

### Inherited by implicit conversion traversable2ops from ArrayStack[T] to TraversableOps[T]

### Inherited by implicit conversion MonadOps from ArrayStack[T] to MonadOps[T]

### Inherited by implicit conversion any2stringadd from ArrayStack[T] to StringAdd

### Inherited by implicit conversion any2stringfmt from ArrayStack[T] to StringFormat

### Inherited by implicit conversion any2ArrowAssoc from ArrayStack[T] to ArrowAssoc[ArrayStack[T]]

### Inherited by implicit conversion any2Ensuring from ArrayStack[T] to Ensuring[ArrayStack[T]]

### Inherited by implicit conversion alternateImplicit from ArrayStack[T] to ForceImplicitAmbiguity

### Ungrouped